/************************************************************
 *															*
 *						coord.h								*
 *			   											    *															*
 *				LPGE     1997								*		
 *															*
 *	Copyright (C) 1996 Sony Computer Entertainment Inc.		*
 *	All Rights Reserved										*
 *															*
 ***********************************************************/




#ifndef COORD_H_INCLUDED



#include "sys_libs.h"

#include "asssert.h"

#include "matrix.h"

#include "dump.h"

#include "object.h"




int CheckCoordinateSystemIsBase (GsCOORDINATE2* coord);

void CopyCoordinateSystem (GsCOORDINATE2* from, GsCOORDINATE2* to);


void ExpressSubPointInSuper (VECTOR* subPoint, 
			GsCOORDINATE2* subSystem, VECTOR* superPointOutput);

void ExpressSuperPointInSub (VECTOR* superPoint, 
			GsCOORDINATE2* subSystem, VECTOR* subPointOutput);



void DeriveNewCoordSystemFromRotation (GsCOORDINATE2* original,
			SVECTOR* rotation, GsCOORDINATE2* output);


void RotateCoordinateSystem (GsCOORDINATE2* original,
			SVECTOR* rotation, GsCOORDINATE2* output);				 



#define COORD_H_INCLUDED 1

#endif
