/************************************************************
 *															*
 *						main.h								*
 *			   											    *															*
 *				LPGE     1997								*		
 *															*
 *	Copyright (C) 1996 Sony Computer Entertainment Inc.		*
 *	All Rights Reserved										*
 *															*
 ***********************************************************/




#ifndef MAIN_H_INCLUDED

	 


/****************************************************************************
					 constants and externed globals
****************************************************************************/


#define MAX_SIZEOF_PRIMITIVE 24
				   
	// GPU packet areas
extern PACKET packetArea[2][1536 * MAX_SIZEOF_PRIMITIVE]; 

extern PACKET packetArea2[2][128 * MAX_SIZEOF_PRIMITIVE];
extern PACKET packetArea3[2][128 * MAX_SIZEOF_PRIMITIVE];
extern PACKET packetArea4[2][128 * MAX_SIZEOF_PRIMITIVE];
extern PACKET packetArea5[2][128 * MAX_SIZEOF_PRIMITIVE];

extern PACKET packetArea6[2][1536 * MAX_SIZEOF_PRIMITIVE];

extern PACKET packetArea7[2][128 * MAX_SIZEOF_PRIMITIVE];


#define USE_FIRST_PACKET_AREA 1001
#define USE_SECOND_PACKET_AREA 1002
#define USE_BOTH_PACKET_AREAS 1003
  

#define OT_LENGTH	9
	// this below is 14 - OT_LENGTH, required for GsSortSobject4
#define OT_SHIFT 5
	// this below is (1<<OT_LENGTH)-1
#define FURTHEST_BACK_OT_VALUE 511


#define SECOND_OT_LENGTH 4
	// this below is 14 - OT_LENGTH, required for GsSortSobject4
#define SECOND_OT_SHIFT 10
	// this below is (1<<SECOND_OT_LENGTH)-1
#define FURTHEST_BACK_SECOND_OT_VALUE 15		

extern GsOT Wot[2];			/* Handler of OT */
extern GsOT_TAG wtags[2][1<<OT_LENGTH];

extern GsOT Wot2[2];			/* Handler of OT */
extern GsOT_TAG wtags2[2][1<<SECOND_OT_LENGTH];

extern GsOT Wot3[2];			/* Handler of OT */
extern GsOT_TAG wtags3[2][1<<SECOND_OT_LENGTH];

extern GsOT Wot4[2];			/* Handler of OT */
extern GsOT_TAG wtags4[2][1<<SECOND_OT_LENGTH];

extern GsOT Wot5[2];			/* Handler of OT */
extern GsOT_TAG wtags5[2][1<<SECOND_OT_LENGTH];

extern GsOT Wot6[2];			/* Handler of OT */
extern GsOT_TAG wtags6[2][1<<OT_LENGTH];

extern GsOT Wot7[2];			/* Handler of OT */
extern GsOT_TAG wtags7[2][1<<SECOND_OT_LENGTH];



	// view and projection

#define FIXED_PROJECTION_DISTANCE 252
#define VERY_LOW_PROJECTION_DISTANCE 50

extern long ProjectionDistance;


#define REFERENCE_VIEW 9001
#define MATRIX_VIEW 9002
extern int ViewTypeFlag;

extern GsRVIEW2 TheView;
extern GsVIEW2 TheMatrixView;

extern VECTOR ViewPointPosition, ViewPointDirection;
extern int ViewPointSection, ViewPointGrossDirection;
extern int ViewAngleToSplinePath;

 

	// lighting
extern GsF_LIGHT TheLights[3];

extern CVECTOR InitiallyRed, InitiallyGreen, InitiallyBlue;

extern GsFOGPARAM TheFogging;

extern int OverallLightMode;



	// screen and video mode
extern int ScreenWidth, ScreenHeight;
#define LOW_RES 0
#define HI_RES 1
extern int ScreenResolution;

extern int ScreenVideoMode;
extern int MaximumGameFramesPerSecond;
extern int MaximumScanLinesPerFrame;

extern int CurrentFrameRate;
extern int FrameRateDivider;

extern int StoreScreenFlag;




extern GsGLINE	SpeedLines[16];




extern GsIMAGE AsciiTextureInfo;
extern GsSPRITE AsciiSetSprite;

extern GsIMAGE FireBackgroundImageInfo;
extern GsSPRITE FireBackgroundSprite;



extern GsIMAGE BarRedTextureInfo;
extern GsSPRITE BarRedSprite;
extern GsIMAGE SimpleBlueTextureInfo;
extern GsSPRITE SimpleBlueSprite;

extern GsIMAGE BarSpectrumTextureInfo;
extern GsSPRITE BarSpectrumSprite;
extern GsIMAGE SmoothSpectrumTextureInfo;
extern GsSPRITE SmoothSpectrumSprite;
extern GsIMAGE SmoothRedTextureInfo;
extern GsSPRITE SmoothRedSprite;

extern GsIMAGE Arrow2TextureInfo;
extern GsSPRITE Arrow2Sprite;
extern GsIMAGE Chevron1TextureInfo;
extern GsSPRITE ChevronSprite;
extern GsIMAGE CircleTextureInfo;
extern GsSPRITE CircleSprite;



extern GsIMAGE HorizontalLargeTextureInfo;
extern GsSPRITE HorizontalLargeSprite;
extern GsIMAGE PanelTextureInfo;
extern GsSPRITE PanelSprite;



extern GsIMAGE Wave16TextureInfo;
extern GsIMAGE DynamicAreaTwoTextureInfo;
extern GsIMAGE DynamicAreaThreeTextureInfo;
extern GsIMAGE DynamicAreaFourTextureInfo;

extern GsIMAGE TileFiveTextureInfo;
extern GsSPRITE TileFiveSprite;

extern GsIMAGE FireTextureInfo;
extern GsSPRITE FireSprite;
extern GsIMAGE Spectrum2TextureInfo;
extern GsSPRITE Spectrum2Sprite;
extern GsIMAGE Spectrum3TextureInfo;
extern GsSPRITE Spectrum3Sprite;


extern GsIMAGE Number1TextureInfo;
extern GsSPRITE Number1Sprite;
extern GsIMAGE Number2TextureInfo;
extern GsSPRITE Number2Sprite;
extern GsIMAGE Number3TextureInfo;
extern GsSPRITE Number3Sprite;
extern GsIMAGE Number4TextureInfo;
extern GsSPRITE Number4Sprite;
extern GsIMAGE Number5TextureInfo;
extern GsSPRITE Number5Sprite;
extern GsIMAGE Number6TextureInfo;
extern GsSPRITE Number6Sprite;
extern GsIMAGE Number7TextureInfo;
extern GsSPRITE Number7Sprite;
extern GsIMAGE Number8TextureInfo;
extern GsSPRITE Number8Sprite;
extern GsIMAGE Number9TextureInfo;
extern GsSPRITE Number9Sprite;
extern GsIMAGE Number10TextureInfo;
extern GsSPRITE Number10Sprite;
extern GsIMAGE Number11TextureInfo;
extern GsSPRITE Number11Sprite;
extern GsIMAGE Number12TextureInfo;
extern GsSPRITE Number12Sprite;
extern GsIMAGE Number13TextureInfo;
extern GsSPRITE Number13Sprite;
extern GsIMAGE Number14TextureInfo;
extern GsSPRITE Number14Sprite;
extern GsIMAGE Number15TextureInfo;
extern GsSPRITE Number15Sprite;
extern GsIMAGE Number16TextureInfo;
extern GsSPRITE Number16Sprite;
extern GsIMAGE Number17TextureInfo;
extern GsSPRITE Number17Sprite;
extern GsIMAGE Number18TextureInfo;
extern GsSPRITE Number18Sprite;
extern GsIMAGE Number19TextureInfo;
extern GsSPRITE Number19Sprite;
extern GsIMAGE Number20TextureInfo;
extern GsSPRITE Number20Sprite;
extern GsIMAGE Number21TextureInfo;
extern GsSPRITE Number21Sprite;
extern GsIMAGE Number22TextureInfo;
extern GsSPRITE Number22Sprite;
extern GsIMAGE Number23TextureInfo;
extern GsSPRITE Number23Sprite;
extern GsIMAGE Number24TextureInfo;
extern GsSPRITE Number24Sprite;
extern GsIMAGE Number25TextureInfo;
extern GsSPRITE Number25Sprite;
extern GsIMAGE Number26TextureInfo;
extern GsSPRITE Number26Sprite;
extern GsIMAGE Number27TextureInfo;
extern GsSPRITE Number27Sprite;
extern GsIMAGE Number28TextureInfo;
extern GsSPRITE Number28Sprite;
extern GsIMAGE Number29TextureInfo;
extern GsSPRITE Number29Sprite;


extern GsIMAGE Wave15ImageInfo;
extern GsSPRITE Wave15Sprite;

extern GsIMAGE ShipDynamicAreaTwo;
extern GsIMAGE ShipDynamicAreaThree;
extern GsIMAGE ShipDynamicAreaFour;
extern GsIMAGE ShipDynamicAreaFive;
extern GsIMAGE ShipDynamicAreaSix;



extern GsIMAGE Number30TextureInfo;	  // image3
extern GsSPRITE Number30Sprite;
extern GsIMAGE Number31TextureInfo;	  // image4
extern GsSPRITE Number31Sprite;
extern GsIMAGE Number32TextureInfo;	  // image5
extern GsSPRITE Number32Sprite;
extern GsIMAGE Number33TextureInfo;	  // image6
extern GsSPRITE Number33Sprite;
extern GsIMAGE Number34TextureInfo;	   // image7
extern GsSPRITE Number34Sprite;
extern GsIMAGE Number35TextureInfo;	  // image8
extern GsSPRITE Number35Sprite;
extern GsIMAGE Number36TextureInfo;	  // image11
extern GsSPRITE Number36Sprite;
extern GsIMAGE Number37TextureInfo;	   // image13
extern GsSPRITE Number37Sprite;
extern GsIMAGE Number38TextureInfo;	   // image14
extern GsSPRITE Number38Sprite;
extern GsIMAGE Number39TextureInfo;	   // image16 
extern GsSPRITE Number39Sprite;
extern GsIMAGE Number40TextureInfo;	  // image18
extern GsSPRITE Number40Sprite;
extern GsIMAGE Number41TextureInfo;	  // image19
extern GsSPRITE Number41Sprite;
extern GsIMAGE Number42TextureInfo;	  // image21
extern GsSPRITE Number42Sprite;
extern GsIMAGE Number43TextureInfo;	  // image22
extern GsSPRITE Number43Sprite;
extern GsIMAGE Number44TextureInfo;	   // image23
extern GsSPRITE Number44Sprite;
extern GsIMAGE Number45TextureInfo;	  // image25
extern GsSPRITE Number45Sprite;
extern GsIMAGE Number46TextureInfo;	  // image68
extern GsSPRITE Number46Sprite;
extern GsIMAGE Number47TextureInfo;	   // image71
extern GsSPRITE Number47Sprite;
extern GsIMAGE Number48TextureInfo;	   // image84
extern GsSPRITE Number48Sprite;
extern GsIMAGE Number49TextureInfo;	   // image111 
extern GsSPRITE Number49Sprite;
extern GsIMAGE Number50TextureInfo;	   // oden
extern GsSPRITE Number50Sprite;
extern GsIMAGE Number51TextureInfo;	   // dbtile
extern GsSPRITE Number51Sprite;
extern GsIMAGE Number52TextureInfo;	   // dirtchek 
extern GsSPRITE Number52Sprite;



extern GsIMAGE Spiral1TextureInfo;	    
extern GsSPRITE Spiral1Sprite;
extern GsIMAGE Spiral2TextureInfo;	    
extern GsSPRITE Spiral2Sprite;
extern GsIMAGE Spiral3TextureInfo;	    
extern GsSPRITE Spiral3Sprite;
extern GsIMAGE Spiral4TextureInfo;	    
extern GsSPRITE Spiral4Sprite;



extern GsSPRITE ScreenSprite;




	// global sprites
#define MAX_GLOBAL_SPRITES 128
extern GsSPRITE *GlobalSpriteList[MAX_GLOBAL_SPRITES];
extern int NumberGlobalSprites;
extern int SelectedGlobalSprite;
extern int ShowGlobalSpriteFlag;



	// global images
#define MAX_GLOBAL_IMAGES 128
extern GsIMAGE *GlobalImageList[MAX_GLOBAL_IMAGES];
extern int NumberGlobalImages;




	// image ids
#define ASCII_TEXTURE_ID 0
#define FIRE_BACKGROUND_TEXTURE_ID 1
#define BAR_RED_TEXTURE_ID 2
#define SIMPLE_BLUE_TEXTURE_ID 3
#define BAR_SPECTRUM_TEXTURE_ID 4
#define SMOOTH_SPECTRUM_TEXTURE_ID 5
#define SMOOTH_RED_TEXTURE_ID 6
#define ARROW_2_TEXTURE_ID 7
#define CHEVRON_1_TEXTURE_ID 8
#define CIRCLE_TEXTURE_ID 9
#define HORIZONTAL_LARGE_TEXTURE_ID 10
#define PANEL_TEXTURE_ID 11
#define WAVE_16_TEXTURE_ID 12
#define DYNAMIC_AREA_2_TEXTURE_ID 13
#define DYNAMIC_AREA_3_TEXTURE_ID 14
#define DYNAMIC_AREA_4_TEXTURE_ID 15
#define TILE_FIVE_TEXTURE_ID 16
#define FIRE_TEXTURE_ID 17
#define SPECTRUM_2_TEXTURE_ID 18
#define SPECTRUM_3_TEXTURE_ID 19

#define NUMBER_1_TEXTURE_ID 20
#define NUMBER_2_TEXTURE_ID 21
#define NUMBER_3_TEXTURE_ID 22
#define NUMBER_4_TEXTURE_ID 23
#define NUMBER_5_TEXTURE_ID 24
#define NUMBER_6_TEXTURE_ID 25
#define NUMBER_7_TEXTURE_ID 26
#define NUMBER_8_TEXTURE_ID 27
#define NUMBER_9_TEXTURE_ID 28
#define NUMBER_10_TEXTURE_ID 29
#define NUMBER_11_TEXTURE_ID 30
#define NUMBER_12_TEXTURE_ID 31
#define NUMBER_13_TEXTURE_ID 32
#define NUMBER_14_TEXTURE_ID 33
#define NUMBER_15_TEXTURE_ID 34
#define NUMBER_16_TEXTURE_ID 35
#define NUMBER_17_TEXTURE_ID 36
#define NUMBER_18_TEXTURE_ID 37
#define NUMBER_19_TEXTURE_ID 38
#define NUMBER_20_TEXTURE_ID 39
#define NUMBER_21_TEXTURE_ID 40
#define NUMBER_22_TEXTURE_ID 41
#define NUMBER_23_TEXTURE_ID 42
#define NUMBER_24_TEXTURE_ID 43
#define NUMBER_25_TEXTURE_ID 44
#define NUMBER_26_TEXTURE_ID 45
#define NUMBER_27_TEXTURE_ID 46
#define NUMBER_28_TEXTURE_ID 47
#define NUMBER_29_TEXTURE_ID 48

#define NUMBER_30_TEXTURE_ID 49
#define NUMBER_31_TEXTURE_ID 50
#define NUMBER_32_TEXTURE_ID 51
#define NUMBER_33_TEXTURE_ID 52
#define NUMBER_34_TEXTURE_ID 53
#define NUMBER_35_TEXTURE_ID 54
#define NUMBER_36_TEXTURE_ID 55
#define NUMBER_37_TEXTURE_ID 56
#define NUMBER_38_TEXTURE_ID 57
#define NUMBER_39_TEXTURE_ID 58
#define NUMBER_40_TEXTURE_ID 59
#define NUMBER_41_TEXTURE_ID 60
#define NUMBER_42_TEXTURE_ID 61
#define NUMBER_43_TEXTURE_ID 62
#define NUMBER_44_TEXTURE_ID 63
#define NUMBER_45_TEXTURE_ID 64
#define NUMBER_46_TEXTURE_ID 65
#define NUMBER_47_TEXTURE_ID 66
#define NUMBER_48_TEXTURE_ID 67
#define NUMBER_49_TEXTURE_ID 68
#define NUMBER_50_TEXTURE_ID 69
#define NUMBER_51_TEXTURE_ID 70
#define NUMBER_52_TEXTURE_ID 71
							
#define SPIRAL_1_TEXTURE_ID 72
#define SPIRAL_2_TEXTURE_ID 73
#define SPIRAL_3_TEXTURE_ID 74
#define SPIRAL_4_TEXTURE_ID 75



	// dynamic texture debug flags
extern int DrawProcessesClippingFlag;


extern int DebugDynTexMarker;

extern int DebugSelectedDrawProcess;



// not currently used

//extern GsBOXF FadeBox;

//extern int BackgroundColourRed, BackgroundColourGreen, BackgroundColourBlue;



	   



extern int frameNumber;

extern int hsync;

extern int maxHsync;

extern int gpuLoad, cpuLoad;

extern int bufferIndex;

extern int frameLimiter;

extern int GlobalPauseFlag;


#define SQUARE_SIZE 128


	// object types
#define PLAYER_ONES_SHIP 0
#define PLAYER_TWOS_SHIP 1
#define CUBE 2
#define SQUARE 3
#define OTHER_SHIP 4



extern ObjectHandler PlayerOnesShip;
extern ObjectHandler PlayerTwosShip;


#define MAX_OTHER_SHIPS 6
extern ObjectHandler OtherShips[MAX_OTHER_SHIPS];



#define BASE_SHIP_LIGHT_EFFECT (FIRST)
#define NUMBER_SHIP_LIGHT_EFFECTS (12)
extern int GlobalShipLightingEffectFlag;


#define NUMBER_SHIP_MODELS 7
extern u_long ShipModelAddresses[NUMBER_SHIP_MODELS];


extern int BaseAccelerationPower;
extern int BaseBrakePower;
extern int BaseAngularTwist;
extern int BaseMovementFrictionCoefficient;
extern int BaseAngularFrictionCoefficient;
extern int BaseDiscreteSpeed;



	 


#define FRAME_DELAY_BEFORE_RACE 60

#define MAX_SHIPS_PER_RACE 5

#define MAX_LAPS_IN_RACE 50

extern int FrameWhenRaceStarts;

extern int RaceFrameCounter;

extern int NumberOfLapsInRace;

extern int NumberOfShipsInRace;



#define TILT_ANGLE_FROM_TILT_RATIO 16
#define SHIPS_TILTING_FLAG 1

extern ObjectHandler *ShipsInTunnel[MAX_SHIPS_PER_RACE];
extern ObjectHandler *TheViewShip;
extern GsCOORDINATE2 ViewShipCoordinates;

extern int ChosenSetTrack;

extern int InitialPositions[MAX_SHIPS_PER_RACE];
extern int FinalPositions[MAX_SHIPS_PER_RACE];

extern int EndRaceNowFlag;

extern int RaceOnFlag;



#define CREATE_TRACKS_BY_FUNCTION 1001
#define CREATE_TRACKS_BY_LOADING_DATAFILE 1002

#define TRACK_CREATION_METHOD (CREATE_TRACKS_BY_LOADING_DATAFILE)





		 
	// simple font-printing
extern char SimplePrintString1[64];
extern char SimplePrintString2[64];
extern char SimplePrintString3[64];
extern char SimplePrintString4[64];
extern char SimplePrintString5[64];
extern char SimplePrintString6[64];

extern char TextStringList[12][64];

extern int fontStream1ID;
extern int fontStream2ID;
extern int currentFontStream;



#define GRID_GRANULARITY 20

extern int ShowGlobalGridFlag;

extern GsLINE GridLines[(GRID_GRANULARITY+1)];





extern int SystemInUse;





extern long StackSavePointer;




extern int JasonTuneOnFlag;

#define NUMBER_CD_TRACKS 16

extern int CompactDiscMusicPlayFlag;
extern int CompactDiscTrackNumber;
extern int CompactDiscVolumeSetting;

extern int CompactDiscTrackList[NUMBER_CD_TRACKS];

extern int SoundToGraphicInUseFlag;

extern signed short CdBuffer[4096];
extern signed short *CdDataPointer;
extern int Cd32foldBuffer[32];
extern int Cd16foldBuffer[16];
extern int Cd8foldBuffer[8];
extern int Cd4foldBuffer[4];
extern int CdTotalLeftVolume, CdTotalRightVolume;
extern int CdTotalVolume;






#define MAX_PROFILE_TIMES 50



#define MAX_GAME_MODES 12

#define OPENING_SEQUENCE 0
#define MAIN_MENU 1
#define DURING_THE_RACE 2
#define VIEWING_THE_TRACKS 3
#define SETTING_UP_FREE_PRACTICE 4
#define SETTING_UP_STRAIGHT_RACE 5
#define SETTING_UP_TRACK_VIEWING 6
#define SETTING_UP_ROLLING_DEMO 7
#define SETTING_UP_TWO_PLAYER_RACE 8
#define TWO_PLAYER_RACE 9
#define SETTING_UP_MUSIC_OPTIONS 10
#define QUIT_PROGRAM_COMPLETELY 11




#define STRAIGHT_RACE 0
#define VIEW_THE_TRACKS 1
#define ROLLING_DEMO 2
#define FREE_PRACTICE 3
#define TWO_PLAYERS_RACING 4
#define SET_MUSIC_OPTIONS 5








#define START_FREE_PRACTICE 1001
#define START_STRAIGHT_RACE 1002
#define START_TRACK_VIEWING 1003
#define START_ROLLING_DEMO 1004
#define START_TWO_PLAYER_RACE 1005



#define REDUCE_RESOLUTION_FOR_TWO_PLAYER_MODE 1
#define DRAW_DISTANCE_REDUCED_FOR_TWO_PLAYER_MODE 0



	// fre practice, one player
#define ONLY_MAIN_MODES_USE_HI_RES_FLAG 1

extern int MainMenuChoice;

extern int OverallGameState;

extern int StateChangeWaitingFlag;

extern int GameStatesScreenResolutionFlags[MAX_GAME_MODES];




/****************************************************************************
					 prototypes
****************************************************************************/




void CleanUpProgram (void);

GsIMAGE *GetImageGivenID (int id);

int GetImageIdGivenPointer (GsIMAGE *imagePointer);

void SetModelTypeForAllShips (int whichModel);

void SetModelForShip (int whichModel, ObjectHandler *object);

void SetRandomModelForShip (ObjectHandler *object);

void SetPlayerOnesShipModel (int whichModel);

void SetPlayerTwosShipModel (int whichModel);

void SetFirstOtherShipModel (int whichModel);

void SetBothPlayersShipModel  (int whichModel);

void InitialiseObjects (void);

void ResetShipModelsToDefault (void);

void InitialiseLighting (void);

void SortFntPrint (void);

void SetThreeWhiteLights (void);

void SetTheAbsenceOfFlatLight (void);

void SetThreeColouredLights (void);

void InitialiseRace	(void);

void HandleControllerDrivenShip (ObjectHandler *ship, int padData);

void HandleAllObjects (void);

void PickNewAppearanceForShips (void);

void SortCoordFromMatrix (ObjectHandler *object);

void SortMatrixFromAngle (ObjectHandler *object);

void GetShipMatrixWithoutTilt (ObjectHandler *object, MATRIX *output);

void SortViewShipCoordinates (void);

void SetObjectsInteractivity (int flag);

void SetUpPlayerOnesShip (void);

u_short SortSpriteObjectPosition (ObjectHandler* object);

void DealWithControllerPad (void);

int HandleSystemControls (long pad);

void ClearPrintStrings (void);
void GuiLoopForSeveralFntPrints (void);


void GuiLoopForDisplayingStrings (int numberOfStrings,	
			int initialFrameDelay);

void InitProfiler (void);
void GetTimeBefore (void);
void GetTimeAfter (void);
void PrintTimingData (void);

void InitProfiler2 (void);
void GetTimeNow (void);
void PrintTimingData2 (void);

void SortAllShipsParametersByFrameRate (void);

long FramesToSeconds (int frames);

void ResetGraphicResolution (int newScreenWidth, int newScreenHeight);


void InitTimePeriodOscillation (int oscillationPeriod,
			int minValue, int maxValue, int *affectedPeriod);
void HandleTimePeriodOscillation (void);
void ClearTimePeriodOscillation (void);


//void ClearScreenToColour (int r, int g, int b);

int GetSpeedOfViewShip (void);

int GetSpeedFractionOfViewShip (void);


void PutStackOntoDataCache (void);
void RestoreStackFromDataCache (void);


void InitialiseRandomNumbers (void);


void InitialiseGrid (void);

void DrawGrid (GsOT *ot);


void CalculateCurrentFrameRate (int hsync);



void SetUpSquareDots (void);

int GetNextIndex (int start, int direction, int displacement);

void GetXandYofPointIndex (int index, int *x, int *y);



void StoreScreen (void);



void SetPacketAreaInSystem (int whichOne, int bufferIndex);



#define MAIN_H_INCLUDED 1

#endif