ASM             = asmpsx
CC              = ccpsx
LINK            = psylink
CCOPTIONS  =  -c -Wall -O3 -comments-c++


# Define to compile with None2.lib. Otherwise, libsn.lib is used.
# NONE2       =



# ------------------------------------------------------------------------------

CCOPTS		= -c -Wall -O3 -comments-c++

 
LINKOPTS        = /m /c /g /n999 

# ------------------------------------------------------------------------------



OBJECTS	= pad.obj 2d1.obj text_str.obj sound.obj \
			tmd.obj object.obj trig.obj matrix.obj vector.obj coord.obj	\
			tunnel.obj tunnel2.obj flying.obj \
			menu.obj menu_mod.obj tracks.obj cd_data.obj main.obj \
			drawproc.obj camera.obj	camera2.obj

HEADERS = pad.h 2d1.h text_str.h dump.h asssert.h general.h \
			address.h sound.h tmd.h object.h trig.h	matrix.h vector.h \
			coord.h	tunnel.h tunnel2.h flying.h	\
			menu.h menu_mod.h tracks.h sys_libs.h \
			tracks.h drawproc.h tmdutil.h tmd2.h camera.h camera2.h cd_data.h

BASIC_HEADERS = general.h asssert.h dump.h sys_libs.h trig.h





all: main.cpe

	

main.cpe: $(OBJECTS) main.lnk
    $(LINK) $(LINKOPTS) @main.lnk,main.cpe,main.sym,main.map



main.obj: main.c main.h $(HEADERS) $(BASIC_HEADERS)
	$(CC) $(CCOPTIONS) main.c -omain.obj

pad.obj: pad.c pad.h $(BASIC_HEADERS)
	$(CC) $(CCOPTIONS) pad.c -opad.obj

2d1.obj: 2d1.c 2d1.h $(BASIC_HEADERS)
	$(CC) $(CCOPTIONS) 2d1.c -o2d1.obj

2d2.obj: 2d2.c 2d2.h $(BASIC_HEADERS)
	$(CC) $(CCOPTIONS) 2d2.c -o2d2.obj
	
tmd.obj: tmd.c tmd.h tmd2.c tmd2.h tmdutil.h $(BASIC_HEADERS)
	$(CC) $(CCOPTIONS) tmd.c -otmd.obj
	
rand.obj: rand.c rand.h $(BASIC_HEADERS)
	$(CC) $(CCOPTIONS) rand.c -orand.obj
	
text_str.obj: text_str.c text_str.h 2d1.h address.h $(BASIC_HEADERS) main.h
	$(CC) $(CCOPTIONS) text_str.c -otext_str.obj
	
sound.obj: sound.c sound.h address.h $(BASIC_HEADERS)
	$(CC) $(CCOPTIONS) sound.c -osound.obj
	
object.obj: object.c object.h tmd.h 2d1.h $(BASIC_HEADERS) camera.h	camera2.h
	$(CC) $(CCOPTIONS) object.c -oobject.obj
	
sincos.obj: sincos.c sincos.h	$(BASIC_HEADERS)
	$(CC) $(CCOPTIONS) sincos.c -osincos.obj
	
asincos.obj: asincos.c asincos.h $(BASIC_HEADERS)
	$(CC) $(CCOPTIONS) asincos.c -oasincos.obj
	
tangent.obj: tangent.c tangent.h $(BASIC_HEADERS)
	$(CC) $(CCOPTIONS) tangent.c -otangent.obj
	
atan.obj: atan.c atan.h $(BASIC_HEADERS)
	$(CC) $(CCOPTIONS) atan.c -oatan.obj

trig.obj: trig.c trig.h $(BASIC_HEADERS)
	$(CC) $(CCOPTIONS) trig.c -otrig.obj

matrix.obj: matrix.c matrix.h	$(BASIC_HEADERS)
	$(CC) $(CCOPTIONS) matrix.c -omatrix.obj

vector.obj: vector.c vector.h	$(BASIC_HEADERS)
	$(CC) $(CCOPTIONS) vector.c -ovector.obj

coord.obj: coord.c coord.h matrix.h $(BASIC_HEADERS)
	$(CC) $(CCOPTIONS) coord.c -ocoord.obj

tunnel.obj: tunnel.c tunnel.h tunnel2.h geom.h object.h $(BASIC_HEADERS) main.h address.h tmd.h tmd2.h tmdutil.h camera.h camera2.h
	$(CC) $(CCOPTIONS) tunnel.c -otunnel.obj

tunnel2.obj: tunnel2.c tunnel2.h tunnel.h $(BASIC_HEADERS) main.h object.h flying.h camera.h camera2.h address.h
	$(CC) $(CCOPTIONS) tunnel2.c -otunnel2.obj

flying.obj: flying.c flying.h	$(BASIC_HEADERS) tunnel.h tunnel2.h	main.h
	$(CC) $(CCOPTIONS) flying.c -oflying.obj

menu.obj: menu.c menu.h $(BASIC_HEADERS) tunnel.h tunnel2.h object.h main.h drawproc.h address.h camera.h camera2.h cd_data.h	menu_mod.h
	$(CC) $(CCOPTIONS) menu.c -omenu.obj

menu_mod.obj: menu_mod.c menu_mod.h $(BASIC_HEADERS) tunnel.h tunnel2.h	main.h
	$(CC) $(CCOPTIONS) menu_mod.c -omenu_mod.obj

tracks.obj: tracks.c tracks.h tunnel.h tunnel2.h $(BASIC_HEADERS) main.h object.h
	$(CC) -c -W -O1 -comments-c++ tracks.c -otracks.obj
	
cd_data.obj: cd_data.c cd_data.h $(BASIC_HEADERS) main.h object.h
	$(CC) -c -O2 -comments-c++ cd_data.c -ocd_data.obj

drawproc.obj: drawproc.c drawproc.h $(BASIC_HEADERS) main.h object.h tunnel.h tunnel2.h	cd_data.h
	$(CC) $(CCOPTIONS) drawproc.c -odrawproc.obj

camera.obj: camera.c camera.h camera2.h $(BASIC_HEADERS) main.h object.h tunnel.h tunnel2.h geom.h
	$(CC) $(CCOPTIONS) camera.c	-ocamera.obj

camera2.obj: camera2.c camera2.h camera.h $(BASIC_HEADERS) main.h object.h tunnel.h tunnel2.h geom.h
	$(CC) $(CCOPTIONS) camera2.c -ocamera2.obj







## this needs changing every time batch file changes

#### now using between2.dat
#### overall memory map now same as Yaroze but - 0x00070000
#### see address.h for details

load:
	pqbload between2.dat 80020000
	pqbload spiral1.tim 800c2000
	pqbload spiral2.tim 800c2840
	pqbload spiral3.tim 800c3080
	pqbload spiral4.tim 800c38b0
	pqbload ship6.tmd 80070a00
	pqbload ship31.tmd 80071db0
	pqbload ship32.tmd 80072db0
	pqbload ship26.tmd 800d1600
	pqbload ship42.tmd 800d2f88
	pqbload ship43.tmd 800d4350
	pqbload tracks16.dat 800c4100




#### now using between.dat
#### overall memory map now same as Yaroze but moved downward
#### see address.h for details

#load:
#	pqbload between.dat 80020000
 