/************************************************************
 *															*
 *						matrix.h							*
 *			   											    *															*
 *				LPGE     1997								*		
 *															*
 *	Copyright (C) 1996 Sony Computer Entertainment Inc.		*
 *	All Rights Reserved										*
 *															*
 ***********************************************************/



#ifndef MATRIX_H_INCLUDED



#include "sys_libs.h"

#include "asssert.h"

#include "general.h"





void InitMatrix (MATRIX* matrix);

int MatrixIsUnitMatrix (MATRIX* matrix);

void CopyMatrix (MATRIX* from, MATRIX* to);

void ExpressSuperPointInSubMatrix (VECTOR* subPoint, 
			MATRIX *matrix, VECTOR* superPointOutput);			   

void ExpressSubPointInSuperMatrix (VECTOR* superPoint, 
			MATRIX *matrix, VECTOR* subPointOutput);

void GetMatrixFlippedOnDiagonal (MATRIX *input, MATRIX *output);

void FlipMatrix (MATRIX* input, MATRIX* output);


void DeriveMatrixFromRotation (MATRIX* original,
			SVECTOR* rotation, MATRIX* output);



#define MATRIX_H_INCLUDED 1

#endif



 