/************************************************************
 *															*
 *						menu.h								*
 *			   											    *															*
 *				LPGE     1997								*		
 *															*
 *	Copyright (C) 1996 Sony Computer Entertainment Inc.		*
 *	All Rights Reserved										*
 *															*
 ***********************************************************/




#ifndef MENU_H_INCLUDED




/****************************************************************************
					 includes
****************************************************************************/





#include "sys_libs.h"

#include "pad.h"

#include "sound.h"

#include "object.h"

#include "tunnel.h"

#include "tunnel2.h"

#include "flying.h"

#include "main.h"

#include "menu_mod.h"

#include "tracks.h"

#include "drawproc.h"


   

/****************************************************************************
					 prototypes
****************************************************************************/


void InitialiseTheGameState (void);

void ResetAllGuiLoopQuitFlags (void);

void ResetBasicTunnelSelectionData (void);

void InitialiseGameGivenGameState (void);

void SetANewGameState (int newState);

void HandleGameStateTransition (int oldState, int newState);





void PrepareTheRaceFromSettingUpData (void); 


void PrepareShipsForRace (void);
void PrepareShipsForRace2 (void);

void PrepareTheTrackForViewing (void);





void HandleTheGameStateMachine (void);




void OpeningSequenceLoop (void);

void SortFireBackgroundTextureRGB (GsSPRITE *sprite, int frame);
			  
	  

void GuiLoopForTheMainMenu (void);

void SortOutARollingDemo (void);

void PrepareRollingDemo (int deliberateFlag);

void DealWithControllerForMainMenu (void); 



void GuiLoopWaitingForTheRaceToStart (void);



void GuiLoopForPrintingTheRaceResults (void);



void GuiLoopDuringTheRace (void);

void GuiLoopForTwoPlayerRace (void);

void DrawTheRacingShips (GsOT *ot, int otShift);

void HandleGlobalShipLightingEffect (MATRIX *matrix);


void ClosingSequenceLoop (void);



void GuiLoopForPrintingTextStrings (int numberStrings, char *strings[]);



void PrintMainRaceData (void);


void GuiLoopForViewingTheTracks (void);

void DealWithControlsForTrackViewer (void);




void GuiLoopForSettingUpFreePractice (void);

void GuiLoopForSettingUpStraightRace (void);

void GuiLoopForSettingUpTwoPlayerRace (void);

void GuiLoopForSettingUpTrackViewing (void);

void GuiLoopForSettingUpRollingDemo (void);

void GuiLoopForSettingMusicOptions (void);

void SetUpRollingDemo (void);

void SortOutANewRollingDemo (void);

void SetUpAFreePracticeSession (void);

void SetUpAFullRace (void);

void SetUpTwoPlayerRace (void);

void SetUpARollingDemoSoloAiFlier (int deliberateFlag);

void SetUpARollingDemoAiFliersRace (int deliberateFlag);





void ShowFreePracticeResults (void);

void ShowTwoPlayerRaceResults (void);

void ShowFullRaceResults (void);



void GetStringOfTimeInFrames (int frames, char *output);

void DrawSpeedBar (GsOT *ot, int xBase, int yBase, int speedFraction, 
							int sizeFraction, int maximumWidth);



#define MENU_H_INCLUDED 1

#endif