/************************************************************
 *															*
 *						tracks.c							*
 *			   											    *															*
 *				LPGE     1997								*		
 *															*
 *	Copyright (C) 1996 Sony Computer Entertainment Inc.		*
 *	All Rights Reserved										*
 *															*
 ***********************************************************/




#include "tunnel.h"

#include "tunnel2.h"

#include "flying.h"

#include "tracks.h"





	// building blocks of tunnels
TunnelChunk chunks[MAX_CHUNKS_PER_DESCRIPTION];




#define CLEAR_TRACK_CREATION_DATA					   \
{													   \
	int i;											   \
	for (i = 0; i < MAX_CHUNKS_PER_DESCRIPTION; i++)   \
		{											   \
		flagList[i] = FALSE;						   \
		setRECT( &offsetList[i], 0, 0, 0, 0);		   \
		imageList[i] = NULL;						   \
		}											   \
}




	// use PrintTunnelDescription(track)
	// and 	GenerateAndPrintSplineListOfDescription (thisTrack,
		  // &worldOrigin, &worldMatrix)
	// to print-out (log) all data on a track



void CreateTheSetTracks (void)
{
	TunnelDescription *thisTrack;
	VECTOR worldOrigin;
	MATRIX worldMatrix;
	GsIMAGE *imageList[MAX_CHUNKS_PER_DESCRIPTION];
	int flagList[MAX_CHUNKS_PER_DESCRIPTION];
	RECT offsetList[MAX_CHUNKS_PER_DESCRIPTION];
	//ClutAnimation clutAnimations[MAX_CLUT_ANIMATIONS_PER_DESCRIPTION];
	DrawProcess drawProcesses[MAX_DRAW_PROCESSES_PER_DESCRIPTION];
	//RECT clipArea;
	//u_short offsets[2];
	int i;



		// clear data
	for (i = 0; i < NUMBER_SET_TRACKS; i++)
		{
		InitDescription( &SetTracks[i]);
		}
	for (i = 0; i < MAX_CHUNKS_PER_DESCRIPTION; i++)
		{
		flagList[i] = FALSE;
		setRECT( &offsetList[i], 0, 0, 0, 0);
		imageList[i] = NULL;
		}

		// basic setup (see no point in deviating from this)
   	setVECTOR( &worldOrigin, 0, 0, 0);
	InitMatrix( &worldMatrix);

	


	// NOTE: tracks do not NEED to be declared in the order of their numbers:
	// search for the FIRST to Nth identifiers to find where they appear








#if 0		// OLD: 43 tracks, some a bit poor


		// FIRST

		// two straights split by two semi-circle left-handers
	thisTrack = &SetTracks[FIRST];

	SetTrackClassicShape(thisTrack, FIRST);

	imageList[0] = &BarRedTextureInfo;
	setRECT( &offsetList[0], 0, 0, 64, 64);
	SetTextureDataForTunnelDescription	(thisTrack,
		SINGLE_TUNNEL_TEXTURE, 1, imageList,
			flagList, offsetList, 0);
	
	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);












		// SECOND

	thisTrack = &SetTracks[SECOND];

	SetTrackClassicShape(thisTrack, SECOND);
		
	imageList[0] = &Wave16TextureInfo;
	setRECT( &offsetList[0], 0, 0, 32, 32);
	SetTextureDataForTunnelDescription	(thisTrack,
		SINGLE_TUNNEL_TEXTURE, 1, imageList,
			flagList, offsetList, 0);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);
								
	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								TWENTY_FIRST, FIRST, FIRST); 

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);











		// THIRD

		// two straights split by two semi-circle right-handers
	thisTrack = &SetTracks[THIRD];

	SetTrackClassicShape(thisTrack, THIRD);

	imageList[0] = &DynamicAreaTwoTextureInfo;
	setRECT( &offsetList[0], 0, 0, 32, 32);
	SetTextureDataForTunnelDescription	(thisTrack,
		SINGLE_TUNNEL_TEXTURE, 1, imageList,
			flagList, offsetList, 0);

	SetDrawProcess2( &drawProcesses[0], &DynamicAreaTwoTextureInfo, 
								SEVENTH, FIRST, FIRST);

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);

	SetDescriptionNumberSectionsDrawn(thisTrack, 24);



#if 0
	SetClutAnimation ( &AllClutAnimations[ClutAnimationIndex], &SimpleBlueTextureInfo,
					32, FIRST, 16);
	SetClutAnimationsForTrackDescription (thisTrack,
			1, &AllClutAnimations[ClutAnimationIndex]);
	ClutAnimationIndex++;
#endif
	











		// FOURTH

	thisTrack = &SetTracks[FOURTH];

	SetTrackClassicShape(thisTrack, FOURTH);

	SetDefaultLightingAndTexturingForDescription(thisTrack);

	SetTrackFogging(thisTrack, -8000, 29099400, 0, 0, 0);












		// FIFTH

	thisTrack = &SetTracks[FIFTH];

	SetTrackClassicShape(thisTrack, FIFTH);
		
	SetDefaultLightingAndTexturingForDescription(thisTrack);
	
	SetDescriptionNumberSectionsDrawn(thisTrack, 16);











		// SIXTH

		// full circle right-hander
		// first section alone is straight
	thisTrack = &SetTracks[SIXTH];

	SetTrackClassicShape(thisTrack, SIXTH);

	imageList[0] = &SmoothSpectrumTextureInfo;
	imageList[1] = &DynamicAreaTwoTextureInfo;
	imageList[2] = &SmoothSpectrumTextureInfo;
	imageList[3] = &DynamicAreaTwoTextureInfo;

	flagList[2] = TWIST_NINETY_DEGREES;

	setRECT( &offsetList[0], 0, 0, 64, 32);
	setRECT( &offsetList[1], 0, 0, 32, 32);
	setRECT( &offsetList[2], 0, 0, 64, 32);
	setRECT( &offsetList[3], 0, 0, 32, 32);
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 4, imageList,
			flagList, offsetList, 8);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	SetDescriptionShapesPerSection(thisTrack, 8);

#if 0
	SetClutAnimation ( &AllClutAnimations[ClutAnimationIndex], &BarSpectrumTextureInfo,
                                        120, SECOND, 64);
    SetClutAnimation ( &AllClutAnimations[ClutAnimationIndex+1], &SmoothSpectrumTextureInfo,
                                        120, SECOND, 64);
    SetClutAnimation ( &AllClutAnimations[ClutAnimationIndex+2], &SmoothRedTextureInfo,
                                        120, SECOND, 32);

    SetClutAnimationsForTrackDescription (thisTrack,
                        3, &AllClutAnimations[ClutAnimationIndex]);

	ClutAnimationIndex += 3;
#endif

	SetDrawProcess2( &drawProcesses[0], &DynamicAreaTwoTextureInfo, 
								SIXTH, FIRST, FIRST);

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);

	











		// SEVENTH

	thisTrack = &SetTracks[SEVENTH];

	SetTrackClassicShape(thisTrack, FOURTH);

	imageList[0] = &SmoothSpectrumTextureInfo;
	imageList[1] = &SmoothRedTextureInfo;
	imageList[2] = &TileFiveTextureInfo;

	//setRECT( &offsetList[0], 0, 0, 64, 64);
	//setRECT( &offsetList[1], 0, 0, 64, 32);
	//setRECT( &offsetList[2], 0, 0, 64, 64);
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 3, imageList,
			flagList, offsetList, 27);

	SetDescriptionNumberSectionsDrawn(thisTrack, 24);
	SetDescriptionShapesPerSection(thisTrack, 6);
	SetTrackFogging(thisTrack, -12496, 29099400, 0, 0, 0);


#if 0
	SetClutAnimation ( &AllClutAnimations[ClutAnimationIndex], &BarSpectrumTextureInfo,
					120, SECOND, 64);
	SetClutAnimation ( &AllClutAnimations[ClutAnimationIndex+1], &SmoothSpectrumTextureInfo,
					120, SECOND, 64);
	SetClutAnimation ( &AllClutAnimations[ClutAnimationIndex+2], &SmoothRedTextureInfo,
					120, SECOND, 32);
	SetClutAnimation ( &AllClutAnimations[ClutAnimationIndex+3], &BarRedTextureInfo,
					32, FIRST, 16);

	SetClutAnimationsForTrackDescription (thisTrack,
			4, &AllClutAnimations[ClutAnimationIndex]);

	ClutAnimationIndex += 4;
#endif














		// EIGHTH

		// full circle right-hander
		// first section alone is straight
	thisTrack = &SetTracks[EIGHTH];

	SetTrackClassicShape(thisTrack, SIXTH);

	SetDefaultLightingAndTexturingForDescription(thisTrack);


	SetTrackFogging(thisTrack, -12496, 29099400, 128, 128, 128);
	SetFogEffectForTrack(thisTrack, SECOND);

	SetDescriptionNumberSectionsDrawn(thisTrack, 12);














		// NINTH	   
		
		// complex circular curler

	thisTrack = &SetTracks[NINTH];

	SetTrackClassicShape(thisTrack, FIFTH);
	

	imageList[0] = &Chevron1TextureInfo;
	flagList[0] = TWIST_NINETY_DEGREES;
	setRECT( &offsetList[0], 0, 0, 64, 32);
	

	SetTextureDataForTunnelDescription	(thisTrack,
		SINGLE_TUNNEL_TEXTURE, 1, imageList,
			flagList, offsetList, 0);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_BRIGHTLY_AROUND_AXES, 60);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);
	













		// TENTH

		// two straights, two medium corners
	thisTrack = &SetTracks[TENTH];

	SetTrackClassicShape(thisTrack, SEVENTH);

	imageList[0] = &DynamicAreaTwoTextureInfo;	 
	imageList[1] = &DynamicAreaThreeTextureInfo;
	imageList[2] = &Wave16TextureInfo;
	imageList[3] = &DynamicAreaFourTextureInfo;
	for (i = 0; i < 4; i++)
		{
		setRECT( &offsetList[i], 0, 0, 32, 32);
		} 
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 4, imageList,
			flagList, offsetList, 12);


	SetAmbientLevelForTrack(thisTrack, ONE/2, ONE/2, ONE/2);

	SetDescriptionNumberSectionsDrawn (thisTrack, 16);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetDescriptionNumberSectionsDrawn(thisTrack, 24);
	
	SetDrawProcess2( &drawProcesses[0], &DynamicAreaTwoTextureInfo, 
						TWENTY_EIGHTH, FIRST, FIRST);
	SetDrawProcess2( &drawProcesses[1], &DynamicAreaThreeTextureInfo, 
						TWENTY_NINTH, SECOND, SECOND);
	SetDrawProcess2( &drawProcesses[2], &Wave16TextureInfo, 
						THIRTIETH, THIRD, THIRD);
	SetDrawProcess2( &drawProcesses[3], &DynamicAreaFourTextureInfo, 
						THIRTY_FIRST, FOURTH, FOURTH);

	SetDrawProcessesForTrack(thisTrack, 4, drawProcesses);


#if 0
	SetClutAnimation ( &AllClutAnimations[ClutAnimationIndex], &HorizontalLargeTextureInfo,
					240, THIRD, 256);

	SetClutAnimationsForTrackDescription (thisTrack,
			1, &AllClutAnimations[ClutAnimationIndex]);

	ClutAnimationIndex += 1;
#endif












		   



		// ELEVENTH

	thisTrack = &SetTracks[ELEVENTH];

	SetTrackClassicShape(thisTrack, SECOND);
		
	imageList[0] = &Wave16TextureInfo;
	setRECT( &offsetList[0], 0, 0, 32, 32);
	SetTextureDataForTunnelDescription	(thisTrack,
		SINGLE_TUNNEL_TEXTURE, 1, imageList,
			flagList, offsetList, 0);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16); 

	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
						FIFTEENTH, FIRST, FIRST);

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);












		// TWELFTH

	thisTrack = &SetTracks[TWELFTH];

	SetTrackClassicShape(thisTrack, SECOND);

	imageList[0] = &Chevron1TextureInfo;
	imageList[1] = &DynamicAreaTwoTextureInfo;	 
	imageList[2] = &Number23TextureInfo;  //&PanelTextureInfo;
	imageList[3] = &Number27TextureInfo;  //&CircleTextureInfo;
	imageList[4] = &Number10TextureInfo;  //&TileFiveTextureInfo;
	imageList[5] = &DynamicAreaThreeTextureInfo;
	imageList[6] = &Wave16TextureInfo;
	imageList[7] = &DynamicAreaFourTextureInfo;
	for (i = 0; i < 8; i++)
		{
		setRECT( &offsetList[i], 0, 0, 64, 32);
		}
	flagList[0] = TWIST_NINETY_DEGREES;			// rotate chevron racing-arrow
	setRECT( &offsetList[1], 0, 0, 32, 32);
	setRECT( &offsetList[2], 0, 0, 32, 32);
	setRECT( &offsetList[3], 0, 0, 32, 32);
	setRECT( &offsetList[5], 0, 0, 32, 32);
	setRECT( &offsetList[6], 0, 0, 32, 32);
	setRECT( &offsetList[7], 0, 0, 32, 32);
	

	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 8, imageList,
			flagList, offsetList, 4);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);


	SetDrawProcess2( &drawProcesses[0], &DynamicAreaTwoTextureInfo, 
								SECOND, FIRST, FIRST);

	SetDrawProcess2( &drawProcesses[1], &DynamicAreaThreeTextureInfo, 
								THIRD, SECOND, SECOND);

	SetDrawProcess2( &drawProcesses[2], &Wave16TextureInfo, 
								NINTH, THIRD, THIRD);

	SetDrawProcess2( &drawProcesses[3], &DynamicAreaFourTextureInfo, 
								TENTH, FOURTH, FOURTH);
	
	SetDrawProcessesForTrack(thisTrack, 4, drawProcesses);












	

	   // THIRTEENTH

	   // four draw processes
	thisTrack = &SetTracks[THIRTEENTH];

	SetTrackClassicShape(thisTrack, SECOND);

	imageList[0] = &Wave16TextureInfo;
	imageList[1] = &DynamicAreaTwoTextureInfo;
	imageList[2] = &DynamicAreaThreeTextureInfo;
	imageList[3] = &DynamicAreaFourTextureInfo;
	for (i = 0; i < 4; i++)
		{
		setRECT( &offsetList[i], 0, 0, 32, 32);
		}
	
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 4, imageList,
			flagList, offsetList, 9);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);


	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								FIRST, FIRST, FIRST);
	SetDrawProcess2( &drawProcesses[1], &DynamicAreaTwoTextureInfo, 
								FOURTH, SECOND, SECOND);
	SetDrawProcess2( &drawProcesses[2], &DynamicAreaThreeTextureInfo, 
								FIFTH, THIRD, THIRD);
	SetDrawProcess2( &drawProcesses[3], &DynamicAreaFourTextureInfo, 
								SIXTH, FOURTH, FOURTH);

	SetDrawProcessesForTrack(thisTrack, 4, drawProcesses);














		// FOURTEENTH

		// use clut animation on the panel texture
	thisTrack = &SetTracks[FOURTEENTH];

	SetTrackClassicShape(thisTrack, FOURTH);

				    
				   
	imageList[0] = &Number23TextureInfo;   //&PanelTextureInfo;
	setRECT( &offsetList[0], 0, 0, 32, 32);
	
	SetTextureDataForTunnelDescription	(thisTrack,
		SINGLE_TUNNEL_TEXTURE, 1, imageList,
			flagList, offsetList, 0);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_BRIGHTLY_AROUND_AXES, 60);

	SetTrackFogging(thisTrack, -12496, 29099400, 128, 0, 0);
	SetFogEffectForTrack(thisTrack, THIRD);

	SetDescriptionNumberSectionsDrawn(thisTrack, 36);
	SetDescriptionShapesPerSection(thisTrack, 8);














		// FIFTEENTH

	thisTrack = &SetTracks[FIFTEENTH];

	SetTrackClassicShape(thisTrack, SECOND);

	imageList[0] = &Wave16TextureInfo;

	setRECT( &offsetList[0], 0, 0, 32, 32);
	SetTextureDataForTunnelDescription	(thisTrack,
		SINGLE_TUNNEL_TEXTURE, 1, imageList,
			flagList, offsetList, 0);

	SetDescriptionNumberSectionsDrawn(thisTrack, 12);

	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								SECOND, SECOND, SECOND);

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);















		// SIXTEENTH

	thisTrack = &SetTracks[SIXTEENTH];

	SetTrackClassicShape(thisTrack, SECOND);
		
	imageList[0] = &Wave16TextureInfo;

	setRECT( &offsetList[0], 0, 0, 32, 32);
	SetTextureDataForTunnelDescription	(thisTrack,
		SINGLE_TUNNEL_TEXTURE, 1, imageList,
			flagList, offsetList, 0);

	SetDescriptionNumberSectionsDrawn(thisTrack, 12);

	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								THIRD, THIRD, THIRD);

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);














		// SEVENTEENTH

	thisTrack = &SetTracks[SEVENTEENTH];

	SetTrackClassicShape(thisTrack, FOURTH);

	imageList[0] = &Wave16TextureInfo;
	imageList[1] = &DynamicAreaTwoTextureInfo;
	imageList[2] = &DynamicAreaThreeTextureInfo;
	for (i = 0; i < 3; i++)
		{
		setRECT( &offsetList[i], 0, 0, 32, 32);
		}

	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 3, imageList,
			flagList, offsetList, 27);

	SetDescriptionNumberSectionsDrawn(thisTrack, 24);
	SetDescriptionShapesPerSection(thisTrack, 6);
	SetTrackFogging(thisTrack, -12496, 29099400, 0, 0, 0);

	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								SEVENTH, FIRST, FIRST);
	SetDrawProcess2( &drawProcesses[1], &DynamicAreaTwoTextureInfo, 
								NINTH, SECOND, SECOND);
	SetDrawProcess2( &drawProcesses[2], &DynamicAreaThreeTextureInfo, 
								TENTH, THIRD, THIRD); 

	SetDrawProcessesForTrack(thisTrack, 3, drawProcesses);












		// EIGHTEENTH

	thisTrack = &SetTracks[EIGHTEENTH];

	SetTrackClassicShape(thisTrack, FIRST);

	imageList[0] = &FireBackgroundImageInfo;

	setRECT( &offsetList[0], 86, 10, 32, 64);	   // portion only
	SetTextureDataForTunnelDescription	(thisTrack,
		SINGLE_TUNNEL_TEXTURE, 1, imageList,
			flagList, offsetList, 0);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	//SetDescriptionNumberSectionsDrawn(thisTrack, 24);
	SetDescriptionShapesPerSection(thisTrack, 16);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);


	







		// NINETEENTH

		// two straights split by two semi-circle left-handers
	thisTrack = &SetTracks[NINETEENTH];

	SetTrackClassicShape(thisTrack, FIRST);

	imageList[0] = &FireBackgroundImageInfo;

	setRECT( &offsetList[0], 182, 10, 32, 64);	   
	SetTextureDataForTunnelDescription	(thisTrack,
		SINGLE_TUNNEL_TEXTURE, 1, imageList,
			flagList, offsetList, 0);
	
	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetDescriptionShapesPerSection(thisTrack, 16);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);











		// TWENTIETH

	   // four draw processes
	thisTrack = &SetTracks[TWENTIETH];

	SetTrackClassicShape(thisTrack, SECOND);

	imageList[0] = &Wave16TextureInfo;
	imageList[1] = &DynamicAreaTwoTextureInfo;
	imageList[2] = &DynamicAreaThreeTextureInfo;
	imageList[3] = &DynamicAreaFourTextureInfo;
	for (i = 0; i < 4; i++)
		{
		setRECT( &offsetList[i], 0, 0, 32, 32);
		}
	
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 4, imageList,
			flagList, offsetList, 9);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);


	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								NINTH, FIRST, FIRST);
	SetDrawProcess2( &drawProcesses[1], &DynamicAreaTwoTextureInfo, 
								TWENTY_THIRD, SECOND, SECOND);
	SetDrawProcess2( &drawProcesses[2], &DynamicAreaThreeTextureInfo, 
								TWENTY_FOURTH, THIRD, THIRD);
	SetDrawProcess2( &drawProcesses[3], &DynamicAreaFourTextureInfo, 
								TWENTY_FIFTH, FOURTH, FOURTH);

	SetDrawProcessesForTrack(thisTrack, 4, drawProcesses);








		// TWENTY_FIRST

	thisTrack = &SetTracks[TWENTY_FIRST];

	SetTrackClassicShape(thisTrack, SECOND);
		
	imageList[0] = &Wave16TextureInfo;
	imageList[1] = &DynamicAreaTwoTextureInfo;
	for (i = 2; i < 32; i += 2)
		{
		imageList[i+0] = imageList[i-2];
		imageList[i+1] = imageList[i-1];
		}
	for (i = 0; i < 32; i++)
		{
		setRECT( &offsetList[i], 0, 0, 32, 32);
		}
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 32, imageList,
			flagList, offsetList, 1);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);


	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								FIRST, FIRST, FIRST);
	SetDrawProcess2( &drawProcesses[1], &DynamicAreaTwoTextureInfo, 
								EIGHTH, SECOND, SECOND); 

	SetDrawProcessesForTrack(thisTrack, 2, drawProcesses);

	













		// TWENTY_SECOND
	thisTrack = &SetTracks[TWENTY_SECOND];

	SetTrackClassicShape(thisTrack, SECOND);
		
	imageList[0] = &Wave16TextureInfo;

	setRECT( &offsetList[0], 0, 0, 32, 32);
	SetTextureDataForTunnelDescription	(thisTrack,
		SINGLE_TUNNEL_TEXTURE, 1, imageList,
			flagList, offsetList, 0);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);
	
	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								TWENTY_SECOND, FIRST, FIRST);

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);













		// TWENTY_THIRD

	thisTrack = &SetTracks[TWENTY_THIRD];

	SetTrackClassicShape(thisTrack, SECOND);
		
	imageList[0] = &Wave16TextureInfo;

	setRECT( &offsetList[0], 0, 0, 32, 32);
	SetTextureDataForTunnelDescription	(thisTrack,
		SINGLE_TUNNEL_TEXTURE, 1, imageList,
			flagList, offsetList, 0);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								NINETEENTH, FIRST, FIRST);

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);













		// TWENTY_FOURTH

	thisTrack = &SetTracks[TWENTY_FOURTH];

	SetTrackClassicShape(thisTrack, SECOND);
		
	imageList[0] = &Wave16TextureInfo;

	setRECT( &offsetList[0], 0, 0, 32, 32);
	SetTextureDataForTunnelDescription	(thisTrack,
		SINGLE_TUNNEL_TEXTURE, 1, imageList,
			flagList, offsetList, 0);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								TWENTIETH, FIRST, FIRST);

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);













		// TWENTY_FIFTH

	thisTrack = &SetTracks[TWENTY_FIFTH];

	SetTrackClassicShape(thisTrack, SECOND);
		
	imageList[0] = &Wave16TextureInfo;

	setRECT( &offsetList[0], 0, 0, 32, 32);
	SetTextureDataForTunnelDescription	(thisTrack,
		SINGLE_TUNNEL_TEXTURE, 1, imageList,
			flagList, offsetList, 0);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);


	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								SIXTEENTH, FIRST, FIRST);

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);












		// TWENTY_SIXTH

	thisTrack = &SetTracks[TWENTY_SIXTH];

	SetTrackClassicShape(thisTrack, SECOND);
		
	imageList[0] = &Wave16TextureInfo;

	setRECT( &offsetList[0], 0, 0, 32, 32);
	SetTextureDataForTunnelDescription	(thisTrack,
		SINGLE_TUNNEL_TEXTURE, 1, imageList,
			flagList, offsetList, 0);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);


	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								SEVENTEENTH, FIRST, FIRST);

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);












		// TWENTY_SEVENTH

	thisTrack = &SetTracks[TWENTY_SEVENTH];

	SetTrackClassicShape(thisTrack, SECOND);	
	
	imageList[0] = &Wave16TextureInfo;

	setRECT( &offsetList[0], 0, 0, 32, 32);
	SetTextureDataForTunnelDescription	(thisTrack,
		SINGLE_TUNNEL_TEXTURE, 1, imageList,
			flagList, offsetList, 0);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);


	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								EIGHTEENTH, FIRST, FIRST);

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);












		// TWENTY_EIGHTH

	thisTrack = &SetTracks[TWENTY_EIGHTH];

	SetTrackClassicShape(thisTrack, EIGHTH);
		
	imageList[0] = &Wave16TextureInfo;

	setRECT( &offsetList[0], 0, 0, 32, 32);
	SetTextureDataForTunnelDescription	(thisTrack,
		SINGLE_TUNNEL_TEXTURE, 1, imageList,
			flagList, offsetList, 0);
	
	SetDescriptionNumberSectionsDrawn(thisTrack, 24);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);


	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								EIGHTEENTH, FIRST, FIRST); 

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);










		// TWENTY_NINTH

	thisTrack = &SetTracks[TWENTY_NINTH];

	SetTrackClassicShape(thisTrack, NINTH);
		
	imageList[0] = &Wave16TextureInfo;

	setRECT( &offsetList[0], 0, 0, 32, 32);
	SetTextureDataForTunnelDescription	(thisTrack,
		SINGLE_TUNNEL_TEXTURE, 1, imageList,
			flagList, offsetList, 0);
	
	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);
 

	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								SIXTEENTH, FIRST, FIRST);

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);










		// THIRTIETH

	thisTrack = &SetTracks[THIRTIETH];

	SetTrackClassicShape(thisTrack, TENTH);
		
	imageList[0] = &Wave16TextureInfo;

	setRECT( &offsetList[0], 0, 0, 32, 32);
	SetTextureDataForTunnelDescription	(thisTrack,
		SINGLE_TUNNEL_TEXTURE, 1, imageList,
			flagList, offsetList, 0);

	
	SetDescriptionNumberSectionsDrawn(thisTrack, 24);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);


	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								SEVENTEENTH, FIRST, FIRST);

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);










		// THIRTY_FIRST

	thisTrack = &SetTracks[THIRTY_FIRST];

	SetTrackClassicShape(thisTrack, ELEVENTH);
		
	imageList[0] = &Wave16TextureInfo;

	setRECT( &offsetList[0], 0, 0, 32, 32);
	SetTextureDataForTunnelDescription	(thisTrack,
		SINGLE_TUNNEL_TEXTURE, 1, imageList,
			flagList, offsetList, 0);
	
	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								TWENTY_FIFTH, FIRST, FIRST);

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);









		// THIRTY_SECOND

	thisTrack = &SetTracks[THIRTY_SECOND];

	SetTrackClassicShape(thisTrack, TWELFTH);
		
	imageList[0] = &Wave16TextureInfo;

	setRECT( &offsetList[0], 0, 0, 32, 32);
	SetTextureDataForTunnelDescription	(thisTrack,
		SINGLE_TUNNEL_TEXTURE, 1, imageList,
			flagList, offsetList, 0);
	
	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								TWENTY_FOURTH, FIRST, FIRST);

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);















		// THIRTY_THIRD

	thisTrack = &SetTracks[THIRTY_THIRD];

	SetTrackClassicShape(thisTrack, ELEVENTH);

	imageList[0] = &Wave16TextureInfo;
	imageList[1] = &DynamicAreaTwoTextureInfo;
	imageList[2] = &DynamicAreaThreeTextureInfo;
	imageList[3] = &DynamicAreaFourTextureInfo;
	for (i = 0; i < 4; i++)
		{
		setRECT( &offsetList[i], 0, 0, 32, 32);
		}
	
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 4, imageList,
			flagList, offsetList, 16);
	
	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);


	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								TWENTY_THIRD, FIRST, FIRST);
	SetDrawProcess2( &drawProcesses[1], &DynamicAreaTwoTextureInfo, 
								TWENTY_FOURTH, SECOND, SECOND);
	SetDrawProcess2( &drawProcesses[2], &DynamicAreaThreeTextureInfo, 
								TWENTY_FIFTH, THIRD, THIRD);
	SetDrawProcess2( &drawProcesses[3], &DynamicAreaFourTextureInfo, 
								TWENTY_SIXTH, FOURTH, FOURTH);

	SetDrawProcessesForTrack(thisTrack, 4, drawProcesses);















		// THIRTY_FOURTH

	thisTrack = &SetTracks[THIRTY_FOURTH];

	SetTrackClassicShape(thisTrack, ELEVENTH);

	imageList[0] = &Wave16TextureInfo;
	imageList[1] = &DynamicAreaTwoTextureInfo;
	imageList[2] = &DynamicAreaThreeTextureInfo;
	imageList[3] = &DynamicAreaFourTextureInfo;
	for (i = 0; i < 4; i++)
		{
		setRECT( &offsetList[i], 0, 0, 32, 32);
		}
	
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 4, imageList,
			flagList, offsetList, 16);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);


	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								FIFTEENTH, FIRST, FIRST);
	SetDrawProcess2( &drawProcesses[1], &DynamicAreaTwoTextureInfo, 
								SIXTEENTH, SECOND, SECOND);
	SetDrawProcess2( &drawProcesses[2], &DynamicAreaThreeTextureInfo, 
								SEVENTEENTH, THIRD, THIRD);
	SetDrawProcess2( &drawProcesses[3], &DynamicAreaFourTextureInfo, 
								EIGHTEENTH, FOURTH, FOURTH);

	SetDrawProcessesForTrack(thisTrack, 4, drawProcesses);














		// THIRTY_FIFTH

	thisTrack = &SetTracks[THIRTY_FIFTH];

	SetTrackClassicShape(thisTrack, TWELFTH);
		
	imageList[0] = &Wave16TextureInfo;

	setRECT( &offsetList[0], 0, 0, 32, 32);
	SetTextureDataForTunnelDescription	(thisTrack,
		SINGLE_TUNNEL_TEXTURE, 1, imageList,
			flagList, offsetList, 0);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetTrackFogging(thisTrack, -6996, 29099400, 128, 0, 0);
	SetFogEffectForTrack(thisTrack, THIRD);


	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								FOURTH, FIRST, FIRST);

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);











		// THIRTY_SIXTH

	thisTrack = &SetTracks[THIRTY_SIXTH];

	SetTrackClassicShape(thisTrack, ELEVENTH);

	SetAmbientLevelForTrack(thisTrack, ONE, ONE, ONE);

	imageList[0] = &Wave16TextureInfo;
	imageList[1] = &Wave16TextureInfo;
	imageList[2] = &Wave16TextureInfo;
	imageList[3] = &Wave16TextureInfo;
	imageList[4] = &Wave16TextureInfo;
	imageList[5] = &Wave16TextureInfo;
	imageList[6] = &Wave16TextureInfo;
	imageList[7] = &Wave16TextureInfo;
	imageList[8] = &Wave16TextureInfo;
	imageList[9] = &Wave16TextureInfo;
	imageList[10] = &Wave16TextureInfo;
	imageList[11] = &SimpleBlueTextureInfo;
	for (i = 0; i < 12; i++)
		{
		setRECT( &offsetList[i], 0, 0, 32, 32);
		}
	setRECT( &offsetList[11], 0, 0, 64, 64);
	
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_POLYGONS, 12, imageList,
			flagList, offsetList, 1 + (1<<8));

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_BRIGHTLY_AROUND_AXES, 60);



	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								TWENTY_SEVENTH, FIRST, FIRST);

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);










		// THIRTY_SEVENTH

	thisTrack = &SetTracks[THIRTY_SEVENTH];

	SetTrackClassicShape(thisTrack, ELEVENTH);

	imageList[0] = &Number2TextureInfo;
	imageList[1] = &Number3TextureInfo;
	imageList[2] = &Number4TextureInfo;
	imageList[3] = &Number5TextureInfo;
	imageList[4] = &Number6TextureInfo;
	imageList[5] = &Number7TextureInfo;
	imageList[6] = &Number8TextureInfo;
	imageList[7] = &Number9TextureInfo;

#if 0
	for (i = 0; i < 8; i++)
		{
		setRECT( &offsetList[i], 0, 0, 64, 64);
		}

	flagList[7] = TWIST_NINETY_DEGREES;
#endif
	
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 8, imageList,
			flagList, offsetList, 8);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetAmbientLevelForTrack(thisTrack, ONE/2, ONE/2, ONE/2);






		// THIRTY_EIGHTH

	thisTrack = &SetTracks[THIRTY_EIGHTH];

	SetTrackClassicShape(thisTrack, ELEVENTH);


	imageList[0] = &Number10TextureInfo;
	imageList[1] = &Number12TextureInfo;
	imageList[2] = &Number14TextureInfo;
	imageList[3] = &Number15TextureInfo;
	imageList[4] = &Wave16TextureInfo;
	imageList[5] = &DynamicAreaFourTextureInfo;
	imageList[6] = &Number18TextureInfo;
	imageList[7] = &Number19TextureInfo;
	for (i = 0; i < 8; i++)
		{
		setRECT( &offsetList[i], 0, 0, 64, 64);
		}
	setRECT( &offsetList[0], 0, 0, 64, 32);
	setRECT( &offsetList[4], 0, 0, 32, 32);
	setRECT( &offsetList[5], 0, 0, 32, 32);
	flagList[0] = TWIST_NINETY_DEGREES;
	flagList[1] = TWIST_NINETY_DEGREES;
	setRECT( &offsetList[0], 0, 0, 64, 32);
	
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 8, imageList,
			flagList, offsetList, 8);
	
	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetAmbientLevelForTrack(thisTrack, ONE/2, ONE/2, ONE/2);

	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								TWENTY_EIGHTH, FIRST, FIRST);
	SetDrawProcess2( &drawProcesses[1], &DynamicAreaFourTextureInfo, 
								TWENTY_NINTH, SECOND, SECOND);
	
	SetDrawProcessesForTrack(thisTrack, 2, drawProcesses);










		// THIRTY_NINTH

	thisTrack = &SetTracks[THIRTY_NINTH];

	SetTrackClassicShape(thisTrack, ELEVENTH);

	imageList[0] = &Number20TextureInfo;
	imageList[1] = &Number22TextureInfo;
	imageList[2] = &Number23TextureInfo;
	imageList[3] = &Number24TextureInfo;
	imageList[4] = &Number25TextureInfo;
	imageList[5] = &Number26TextureInfo;
	imageList[6] = &Number27TextureInfo;
	imageList[7] = &Number29TextureInfo;
	for (i = 0; i < 8; i++)
		{
		setRECT( &offsetList[i], 0, 0, 64, 64);
		}
	setRECT( &offsetList[2], 0, 0, 32, 32);
	setRECT( &offsetList[3], 0, 0, 64, 32);
	setRECT( &offsetList[6], 0, 0, 32, 32);
	flagList[1] = TWIST_NINETY_DEGREES;
	//flagList[3] = TWIST_NINETY_DEGREES;
	flagList[4] = TWIST_NINETY_DEGREES;
	flagList[5] = TWIST_NINETY_DEGREES;
	
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 8, imageList,
			flagList, offsetList, 8);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetAmbientLevelForTrack(thisTrack, ONE/2, ONE/2, ONE/2);












		// FOURTIETH

	thisTrack = &SetTracks[FOURTIETH];

	SetTrackClassicShape(thisTrack, THIRTEENTH);

	imageList[0] = &Number8TextureInfo;
	imageList[1] = &Number23TextureInfo;
	imageList[2] = &Number10TextureInfo;
	imageList[3] = &Number27TextureInfo;

#if 0
	for (i = 0; i < 4; i++)
		{
		setRECT( &offsetList[i], 0, 0, 64, 64);
		}
	setRECT( &offsetList[1], 0, 0, 32, 32);
	setRECT( &offsetList[3], 0, 0, 32, 32);
#endif
	
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 4, imageList,
			flagList, offsetList, 16);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetAmbientLevelForTrack(thisTrack, ONE/2, ONE/2, ONE/2);













		// FORTY_FIRST

	thisTrack = &SetTracks[FORTY_FIRST];

	SetTrackClassicShape(thisTrack, THIRTEENTH);

	imageList[0] = &SimpleBlueTextureInfo;
	imageList[1] = &Number2TextureInfo;
	imageList[2] = &Number7TextureInfo;
	imageList[3] = &Number25TextureInfo;

#if 1
	for (i = 0; i < 4; i++)
		{
		setRECT( &offsetList[i], 0, 0, 64, 64);
		}
	setRECT( &offsetList[2], 0, 0, 0, 0);
#endif
	
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 4, imageList,
			flagList, offsetList, 16);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetAmbientLevelForTrack(thisTrack, ONE/2, ONE/2, ONE/2);










		// FORTY_SECOND

	thisTrack = &SetTracks[FORTY_SECOND];

	SetTrackClassicShape(thisTrack, FOURTEENTH);

	// PROBLEM: only 3 textures set here, 4 used for track,
	// relies on previous data in imageList

	imageList[0] = &Number26TextureInfo;
	imageList[1] = &Number29TextureInfo;
	imageList[2] = &Number3TextureInfo;

#if 0
	for (i = 0; i < 3; i++)
		{
		setRECT( &offsetList[i], 0, 0, 64, 64);
		}
	flagList[0] = TWIST_NINETY_DEGREES;
#endif
	
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 4, imageList,
			flagList, offsetList, 16);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetAmbientLevelForTrack(thisTrack, ONE/2, ONE/2, ONE/2);












		// FORTY_THIRD

	thisTrack = &SetTracks[FORTY_THIRD];

	SetTrackClassicShape(thisTrack, SEVENTH);

	imageList[0] = &DynamicAreaTwoTextureInfo;	 
	imageList[1] = &DynamicAreaThreeTextureInfo;
	imageList[2] = &Wave16TextureInfo;
	imageList[3] = &DynamicAreaFourTextureInfo;
	for (i = 0; i < 4; i++)
		{
		setRECT( &offsetList[i], 0, 0, 32, 32);
		} 
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 4, imageList,
			flagList, offsetList, 12);


	SetAmbientLevelForTrack(thisTrack, ONE/2, ONE/2, ONE/2);

	SetDescriptionNumberSectionsDrawn (thisTrack, 16);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetDescriptionNumberSectionsDrawn(thisTrack, 24);


	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								THIRTY_SECOND, FIRST, FIRST);
	SetDrawProcess2( &drawProcesses[1], &DynamicAreaTwoTextureInfo, 
								THIRTY_THIRD, SECOND, SECOND);
	SetDrawProcess2( &drawProcesses[2], &DynamicAreaThreeTextureInfo, 
								TWENTY_SEVENTH, THIRD, THIRD);
	SetDrawProcess2( &drawProcesses[3], &DynamicAreaFourTextureInfo, 
								TWENTIETH, FOURTH, FOURTH);
	
	SetDrawProcessesForTrack(thisTrack, 4, drawProcesses);


#endif				// OLD: lots of tracks, some poor






#if 1		// NEW TRACKS





		// FIRST

	thisTrack = &SetTracks[FIRST];

	SetTrackClassicShape(thisTrack, TWELFTH);		// FIFTH
		
	//SetDefaultLightingAndTexturingForDescription(thisTrack);
	
	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	imageList[0] = &Chevron1TextureInfo;
	imageList[1] = &DynamicAreaTwoTextureInfo;	 
	imageList[2] = &Number23TextureInfo;  //&PanelTextureInfo;
	imageList[3] = &Number27TextureInfo;  //&CircleTextureInfo;
	imageList[4] = &DynamicAreaThreeTextureInfo;
	imageList[5] = &Wave16TextureInfo;
	imageList[6] = &Number10TextureInfo;  //&TileFiveTextureInfo
	imageList[7] = &DynamicAreaFourTextureInfo;

	flagList[0] = TWIST_NINETY_DEGREES;			// rotate chevron racing-arrow

	setRECT( &offsetList[1], 0, 0, 32, 32);
	setRECT( &offsetList[4], 0, 0, 32, 32);
	setRECT( &offsetList[5], 0, 0, 32, 32);
	setRECT( &offsetList[7], 0, 0, 32, 32);
	

	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 8, imageList,
			flagList, offsetList, 21);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);


	SetDrawProcess2( &drawProcesses[0], &DynamicAreaTwoTextureInfo, 
								SECOND, FIRST, FIRST);

	SetDrawProcess2( &drawProcesses[1], &DynamicAreaThreeTextureInfo, 
								THIRD, SECOND, SECOND);

	SetDrawProcess2( &drawProcesses[2], &Wave16TextureInfo, 
								NINTH, THIRD, THIRD);

	SetDrawProcess2( &drawProcesses[3], &DynamicAreaFourTextureInfo, 
								TENTH, FOURTH, FOURTH);
	
	SetDrawProcessesForTrack(thisTrack, 4, drawProcesses);

	SetTrackFogging(thisTrack, -5500, 29099400, 0, 0, 0);

	CLEAR_TRACK_CREATION_DATA













		// SECOND


	thisTrack = &SetTracks[FIRST];
	

	SetTrackClassicShape(thisTrack, FIFTEENTH);
		
	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	imageList[0] = &Number29TextureInfo;
	imageList[1] = &Wave16TextureInfo;
	imageList[2] = &DynamicAreaTwoTextureInfo;

	for (i = 1; i < 3; i++)
		{
		setRECT( &offsetList[i], 0, 0, 32, 32);
		}
	
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 3, imageList,
			flagList, offsetList, 11);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								FIRST, FIRST, FIRST);
	SetDrawProcess2( &drawProcesses[1], &DynamicAreaTwoTextureInfo, 
								FOURTH, SECOND, SECOND);

	SetDrawProcessesForTrack(thisTrack, 2, drawProcesses);

	SetTrackFogging(thisTrack, -5500, 29099400, 0, 0, 0);

	CLEAR_TRACK_CREATION_DATA
















		// THIRD

	thisTrack = &SetTracks[THIRD];

	SetTrackClassicShape(thisTrack, EIGHTH);
		
	SetDescriptionNumberSectionsDrawn(thisTrack, 24);
	SetDescriptionShapesPerSection(thisTrack, 6);

	imageList[0] = &Wave16TextureInfo;
	imageList[1] = &SmoothSpectrumTextureInfo;
	imageList[2] = &SmoothRedTextureInfo;
	imageList[3] = &TileFiveTextureInfo;

	setRECT( &offsetList[0], 0, 0, 32, 32);
	
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 4, imageList,
			flagList, offsetList, 30);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								THIRTY_SECOND, FIRST, FIRST);

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);

	SetTrackFogging(thisTrack, -5500, 29099400, 0, 0, 0);

	CLEAR_TRACK_CREATION_DATA


	

	
	










		// FOURTH

	thisTrack = &SetTracks[FOURTH];

	SetTrackClassicShape(thisTrack, SECOND);	  // SIXTEENTH
		
	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	imageList[0] = &Wave16TextureInfo;

	setRECT( &offsetList[0], 0, 0, 32, 32);

	flagList[0] = TWIST_NINETY_DEGREES;
	
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 1, imageList,
			flagList, offsetList, 32);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								TENTH, FIRST, FIRST);

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);

	SetTrackFogging(thisTrack, -5500, 29099400, 0, 0, 0);

	CLEAR_TRACK_CREATION_DATA









		// FIFTH

	thisTrack = &SetTracks[FIFTH];

	SetTrackClassicShape(thisTrack, NINTH);
		
	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

#if 0
	imageList[0] = &Number27TextureInfo;
	imageList[1] = &Number8TextureInfo;
	imageList[2] = &Number10TextureInfo;
	
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 3, imageList,
			flagList, offsetList, 26);
#endif

	imageList[0] = &Wave16TextureInfo;
	imageList[1] = &DynamicAreaTwoTextureInfo;

	for (i = 0; i < 2; i++)
		{
		setRECT( &offsetList[i], 0, 0, 32, 32);
		}
	
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 2, imageList,
			flagList, offsetList, 38);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								THIRTY_FOURTH, FIRST, FIRST);
	SetDrawProcess2( &drawProcesses[1], &DynamicAreaTwoTextureInfo, 
								THIRTY_FIFTH, SECOND, SECOND);

	SetDrawProcessesForTrack(thisTrack, 2, drawProcesses);

	SetAmbientLevelForTrack(thisTrack, ONE/2, ONE/2, ONE/2);

	CLEAR_TRACK_CREATION_DATA














#if 0

		// SIXTH

	thisTrack = &SetTracks[SIXTH];

	SetTrackClassicShape(thisTrack, SEVENTEENTH);
		
	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	imageList[0] = &Wave16TextureInfo;
	imageList[1] = &DynamicAreaTwoTextureInfo;

	for (i = 0; i < 2; i++)
		{
		setRECT( &offsetList[i], 0, 0, 32, 32);
		}
	
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 2, imageList,
			flagList, offsetList, 38);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								THIRTY_FOURTH, FIRST, FIRST);
	SetDrawProcess2( &drawProcesses[1], &DynamicAreaTwoTextureInfo, 
								THIRTY_FIFTH, SECOND, SECOND);

	SetDrawProcessesForTrack(thisTrack, 2, drawProcesses);

	CLEAR_TRACK_CREATION_DATA
#endif





		// SIXTH

	thisTrack = &SetTracks[SIXTH];

	SetTrackClassicShape(thisTrack, SECOND);

	imageList[0] = &Chevron1TextureInfo;
	imageList[1] = &DynamicAreaTwoTextureInfo;	 
	imageList[2] = &Number23TextureInfo;  //&PanelTextureInfo;
	imageList[3] = &Number27TextureInfo;  //&CircleTextureInfo;
	imageList[4] = &Number10TextureInfo;  //&TileFiveTextureInfo;
	imageList[5] = &DynamicAreaThreeTextureInfo;
	imageList[6] = &Wave16TextureInfo;
	imageList[7] = &DynamicAreaFourTextureInfo;
	for (i = 0; i < 8; i++)
		{
		setRECT( &offsetList[i], 0, 0, 64, 32);
		}
	flagList[0] = TWIST_NINETY_DEGREES;			// rotate chevron racing-arrow
	setRECT( &offsetList[1], 0, 0, 32, 32);
	setRECT( &offsetList[2], 0, 0, 32, 32);
	setRECT( &offsetList[3], 0, 0, 32, 32);
	setRECT( &offsetList[5], 0, 0, 32, 32);
	setRECT( &offsetList[6], 0, 0, 32, 32);
	setRECT( &offsetList[7], 0, 0, 32, 32);
	

	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 8, imageList,
			flagList, offsetList, 4);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetDescriptionNumberSectionsDrawn(thisTrack, 16);


	SetDrawProcess2( &drawProcesses[0], &DynamicAreaTwoTextureInfo, 
								SECOND, FIRST, FIRST);

	SetDrawProcess2( &drawProcesses[1], &DynamicAreaThreeTextureInfo, 
								THIRD, SECOND, SECOND);

	SetDrawProcess2( &drawProcesses[2], &Wave16TextureInfo, 
								NINTH, THIRD, THIRD);

	SetDrawProcess2( &drawProcesses[3], &DynamicAreaFourTextureInfo, 
								TENTH, FOURTH, FOURTH);
	
	SetDrawProcessesForTrack(thisTrack, 4, drawProcesses);









		// SEVENTH

	thisTrack = &SetTracks[SEVENTH];

	SetTrackClassicShape(thisTrack, TENTH);
		
	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	imageList[0] = &Wave16TextureInfo;

	setRECT( &offsetList[0], 0, 0, 32, 32);
	
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 1, imageList,
			flagList, offsetList, 400);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								THIRTY_SECOND, FIRST, FIRST);

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);

	SetTrackFogging(thisTrack, -5500, 29099400, 0, 0, 0);

	CLEAR_TRACK_CREATION_DATA









		// EIGHTH

	thisTrack = &SetTracks[EIGHTH];

	SetTrackClassicShape(thisTrack, SECOND);
		
   	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	imageList[0] = &Wave16TextureInfo;

	setRECT( &offsetList[0], 0, 0, 32, 32);
	
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 1, imageList,
			flagList, offsetList, 32);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								THIRTY_THIRD, FIRST, FIRST);

	SetDrawProcessesForTrack(thisTrack, 1, drawProcesses);

	SetTrackFogging(thisTrack, -5500, 29099400, 0, 0, 0);

	CLEAR_TRACK_CREATION_DATA







		// NINTH

	thisTrack = &SetTracks[NINTH];

	SetTrackClassicShape(thisTrack, TWELFTH);
		
	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	imageList[0] = &Number15TextureInfo;
	imageList[1] = &Number19TextureInfo;
	imageList[2] = &Number23TextureInfo;
	imageList[3] = &Number25TextureInfo;
	imageList[4] = &Number22TextureInfo;
	imageList[5] = &Number24TextureInfo;
	imageList[6] = &Number6TextureInfo;
	imageList[7] = &Number5TextureInfo;
	
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 8, imageList,
			flagList, offsetList, 22);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetAmbientLevelForTrack(thisTrack, ONE/2, ONE/2, ONE/2);

	SetTrackFogging(thisTrack, -5500, 29099400, 0, 0, 0);

	CLEAR_TRACK_CREATION_DATA












		// TENTH

	thisTrack = &SetTracks[TENTH];

	SetTrackClassicShape(thisTrack, SECOND);		// NINETEENTH
		
	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	imageList[0] = &Number23TextureInfo;
	imageList[1] = &Number26TextureInfo;
	imageList[2] = &Number27TextureInfo;
	imageList[3] = &Number29TextureInfo;
	
	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 4, imageList,
			flagList, offsetList, 8);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);

	SetAmbientLevelForTrack(thisTrack, ONE/2, ONE/2, ONE/2);

	SetTrackFogging(thisTrack, -5500, 29099400, 0, 0, 0);

	CLEAR_TRACK_CREATION_DATA







		// ELEVENTH

	thisTrack = &SetTracks[ELEVENTH];

	SetTrackClassicShape(thisTrack, TWELFTH);		// FIFTH
		
	//SetDefaultLightingAndTexturingForDescription(thisTrack);
	
	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	imageList[0] = &Number4TextureInfo;	 
	imageList[1] = &Number5TextureInfo; 
	imageList[2] = &Number25TextureInfo;
	imageList[3] = &Wave16TextureInfo;
	imageList[4] = &DynamicAreaTwoTextureInfo;    
	imageList[5] = &DynamicAreaThreeTextureInfo;
	imageList[6] = &DynamicAreaFourTextureInfo;

	setRECT( &offsetList[3], 0, 0, 32, 32);
	setRECT( &offsetList[4], 0, 0, 32, 32);
	setRECT( &offsetList[5], 0, 0, 32, 32);
	setRECT( &offsetList[6], 0, 0, 32, 32);
	

	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 7, imageList,
			flagList, offsetList, 24);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);


	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								THIRTY_FIRST, THIRD, THIRD);

	SetDrawProcess2( &drawProcesses[1], &DynamicAreaTwoTextureInfo, 
								FOURTH, FIRST, FIRST);

	SetDrawProcess2( &drawProcesses[2], &DynamicAreaThreeTextureInfo, 
								SIXTH, SECOND, SECOND);

	SetDrawProcess2( &drawProcesses[3], &DynamicAreaFourTextureInfo, 
								TWENTY_FIFTH, FOURTH, FOURTH);
	
	SetDrawProcessesForTrack(thisTrack, 4, drawProcesses);

	SetTrackFogging(thisTrack, -5500, 29099400, 0, 0, 0);

	CLEAR_TRACK_CREATION_DATA








		// TWELFTH

	thisTrack = &SetTracks[TWELFTH];

	SetTrackClassicShape(thisTrack, SECOND);		// TWELFTH
		
	//SetDefaultLightingAndTexturingForDescription(thisTrack);
	
	SetDescriptionNumberSectionsDrawn(thisTrack, 16);

	imageList[0] = &Wave16TextureInfo;
	imageList[1] = &DynamicAreaTwoTextureInfo;    
	imageList[2] = &DynamicAreaThreeTextureInfo;
	imageList[3] = &DynamicAreaFourTextureInfo;

	setRECT( &offsetList[0], 0, 0, 32, 32);
	setRECT( &offsetList[1], 0, 0, 32, 32);
	setRECT( &offsetList[2], 0, 0, 32, 32);
	setRECT( &offsetList[3], 0, 0, 32, 32);
	

	SetTextureDataForTunnelDescription	(thisTrack,
		ONE_TEXTURE_PER_N_SECTIONS, 4, imageList,
			flagList, offsetList, 8);

	SetTrackLighting (thisTrack,
		CYCLE_THREE_LIGHTS_AROUND_AXES, 60);


	SetDrawProcess2( &drawProcesses[0], &Wave16TextureInfo, 
								SECOND, THIRD, THIRD);

	SetDrawProcess2( &drawProcesses[1], &DynamicAreaTwoTextureInfo, 
								THIRD, FIRST, FIRST);

	SetDrawProcess2( &drawProcesses[2], &DynamicAreaThreeTextureInfo, 
								FIFTEENTH, SECOND, SECOND);

	SetDrawProcess2( &drawProcesses[3], &DynamicAreaFourTextureInfo, 
								EIGHTEENTH, FOURTH, FOURTH);
	
	SetDrawProcessesForTrack(thisTrack, 4, drawProcesses);

	SetTrackFogging(thisTrack, -5500, 29099400, 0, 0, 0);

	CLEAR_TRACK_CREATION_DATA


	  

#endif		// NEW TRACKS
}





	// each classic shape: specifies the rotations and lengths
	// of each chunk that makes up the tunnel
	// should ALSO specify: section length and radius
	// should also specify draw and subdiv parameters
	// question: shapes per section????

	// per given shape, will want several choices of:
	// (1) radius and length of sections
	// (2) draw and subdivision parameters (BUT: choose just 1, can alter at runtime)

void SetTrackClassicShape (TunnelDescription *track, int shapeID)
{
	int numberChunks;

	assert(track != NULL);

	switch(shapeID)
		{
		case FIRST:
			numberChunks = 4;

				// two straights, two semi-circle left-hander curves
		   	MakeTunnelChunk( &chunks[0], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[1], 8, 0, ONE/16, 0);
			MakeTunnelChunk( &chunks[2], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[3], 8, 0, ONE/16, 0);

				// make sections shorter than width
			SetDescriptionSizeParameters(track, 
								SQUARE_SIZE * 8, SQUARE_SIZE * 16);
			break;
		case SECOND:
			numberChunks = 2;

				// simple circular track curving to the left
			MakeTunnelChunk( &chunks[0], 1, 0, 0, 0);
			MakeTunnelChunk( &chunks[1], 31, 0, ONE/32, 0);
			break;
		case THIRD:
			numberChunks = 4;

				// two straights, two semi-circle right-hander curves
			MakeTunnelChunk( &chunks[0], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[1], 8, 0, -ONE/16, 0);
			MakeTunnelChunk( &chunks[2], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[3], 8, 0, -ONE/16, 0);
			break;
		case FOURTH:
			numberChunks = 4;

				// two very long straights, two semi-circle left-hander curves
			MakeTunnelChunk( &chunks[0], 32, 0, 0, 0);
			MakeTunnelChunk( &chunks[1], 8, 0, ONE/16, 0);
			MakeTunnelChunk( &chunks[2], 32, 0, 0, 0);
			MakeTunnelChunk( &chunks[3], 8, 0, ONE/16, 0);

			SetDescriptionSizeParameters(track, 
						SQUARE_SIZE * 6, SQUARE_SIZE * 8);
			break;
		case FIFTH:
			numberChunks = 16;

				// smooth-curling starfish with just four limbs, fourfold symmetry
			MakeTunnelChunk( &chunks[0], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[1], 8, 0, -ONE/16, 0);
			MakeTunnelChunk( &chunks[2], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[3], 8, 0, ONE/32, 0);
			MakeTunnelChunk( &chunks[4], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[5], 8, 0, -ONE/16, 0);
			MakeTunnelChunk( &chunks[6], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[7], 8, 0, ONE/32, 0);
			MakeTunnelChunk( &chunks[8], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[9], 8, 0, -ONE/16, 0);
			MakeTunnelChunk( &chunks[10], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[11], 8, 0, ONE/32, 0);
			MakeTunnelChunk( &chunks[12], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[13], 8, 0, -ONE/16, 0);
			MakeTunnelChunk( &chunks[14], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[15], 8, 0, ONE/32, 0);

			SetDescriptionSizeParameters(track, 
						SQUARE_SIZE * 4, SQUARE_SIZE * 4);
			break;
		case SIXTH:
			numberChunks = 2;

				// simple circular track curving to the right
			MakeTunnelChunk( &chunks[0], 1, 0, 0, 0);
			MakeTunnelChunk( &chunks[1], 31, 0, -ONE/32, 0);
			break;
		case SEVENTH:
			numberChunks = 4;

				// two longish straights, two semi-circle left-hander curves
			MakeTunnelChunk( &chunks[0], 16, 0, 0, 0);
			MakeTunnelChunk( &chunks[1], 8, 0, ONE/16, 0);
			MakeTunnelChunk( &chunks[2], 16, 0, 0, 0);
			MakeTunnelChunk( &chunks[3], 8, 0, ONE/16, 0);

			SetDescriptionSizeParameters(track, 
						SQUARE_SIZE * 6, SQUARE_SIZE * 8);
			break;
		case EIGHTH:
			numberChunks = 16;

				// long stretched oval with two outward kinks on each long part
			MakeTunnelChunk( &chunks[0], 12, 0, 0, 0);
			MakeTunnelChunk( &chunks[1], 8, 0, -ONE/16, 0);
			MakeTunnelChunk( &chunks[2], 12, 0, 0, 0);
			MakeTunnelChunk( &chunks[3], 8, 0, ONE/32, 0);
			MakeTunnelChunk( &chunks[4], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[5], 8, 0, -ONE/16, 0);
			MakeTunnelChunk( &chunks[6], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[7], 8, 0, ONE/32, 0);
			MakeTunnelChunk( &chunks[8], 12, 0, 0, 0);
			MakeTunnelChunk( &chunks[9], 8, 0, -ONE/16, 0);
			MakeTunnelChunk( &chunks[10], 12, 0, 0, 0);
			MakeTunnelChunk( &chunks[11], 8, 0, ONE/32, 0);
			MakeTunnelChunk( &chunks[12], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[13], 8, 0, -ONE/16, 0);
			MakeTunnelChunk( &chunks[14], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[15], 8, 0, ONE/32, 0);

			SetDescriptionSizeParameters(track, 
						SQUARE_SIZE * 4, SQUARE_SIZE * 8);
			break;
		case NINTH:
			numberChunks = 14;

				// long stretched oval with kink-to-the-left on each long part
			MakeTunnelChunk( &chunks[0], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[1], 8, 0, -ONE/16, 0);
			MakeTunnelChunk( &chunks[2], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[3], 8, 0, -ONE/32, 0);
			MakeTunnelChunk( &chunks[4], 8, 0, ONE/16, 0);
			MakeTunnelChunk( &chunks[5], 8, 0, -ONE/32, 0);
			MakeTunnelChunk( &chunks[6], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[7], 8, 0, -ONE/16, 0);
			MakeTunnelChunk( &chunks[8], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[9], 8, 0, ONE/32, 0);
			MakeTunnelChunk( &chunks[10], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[11], 8, 0, -ONE/16, 0);
			MakeTunnelChunk( &chunks[12], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[13], 8, 0, ONE/32, 0);

			SetDescriptionSizeParameters(track, 
						SQUARE_SIZE * 4, SQUARE_SIZE * 4);
			break;
		case TENTH:
			numberChunks = 16;

				// smooth-curling starfish with just four limbs, fourfold symmetry
			MakeTunnelChunk( &chunks[0], 16, 0, 0, 0);
			MakeTunnelChunk( &chunks[1], 8, 0, -ONE/16, 0);
			MakeTunnelChunk( &chunks[2], 16, 0, 0, 0);
			MakeTunnelChunk( &chunks[3], 8, 0, ONE/32, 0);
			MakeTunnelChunk( &chunks[4], 16, 0, 0, 0);
			MakeTunnelChunk( &chunks[5], 8, 0, -ONE/16, 0);
			MakeTunnelChunk( &chunks[6], 16, 0, 0, 0);
			MakeTunnelChunk( &chunks[7], 8, 0, ONE/32, 0);
			MakeTunnelChunk( &chunks[8], 16, 0, 0, 0);
			MakeTunnelChunk( &chunks[9], 8, 0, -ONE/16, 0);
			MakeTunnelChunk( &chunks[10], 16, 0, 0, 0);
			MakeTunnelChunk( &chunks[11], 8, 0, ONE/32, 0);
			MakeTunnelChunk( &chunks[12], 16, 0, 0, 0);
			MakeTunnelChunk( &chunks[13], 8, 0, -ONE/16, 0);
			MakeTunnelChunk( &chunks[14], 16, 0, 0, 0);
			MakeTunnelChunk( &chunks[15], 8, 0, ONE/32, 0);

			SetDescriptionSizeParameters(track, 
						SQUARE_SIZE * 4, SQUARE_SIZE * 4);
			break;
		case ELEVENTH:
			numberChunks = 8;

				// rectangle with curved corners, curve to the right
			MakeTunnelChunk( &chunks[0], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[1], 8, 0, -ONE/16, 0);
			MakeTunnelChunk( &chunks[2], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[3], 8, 0, -ONE/16, 0);
			MakeTunnelChunk( &chunks[4], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[5], 8, 0, -ONE/16, 0);
			MakeTunnelChunk( &chunks[6], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[7], 8, 0, -ONE/16, 0);
			break;
		case TWELFTH:
			numberChunks = 17;

				// complex curler: large rectangle with smaller one added halfway down
				// one of the long sides; all corners smoothly rounded
			MakeTunnelChunk( &chunks[0], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[1], 8, 0, -ONE/32, 0);
			MakeTunnelChunk( &chunks[2], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[3], 8, 0, ONE/32, 0);
			MakeTunnelChunk( &chunks[4], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[5], 8, 0, -ONE/32, 0);
			MakeTunnelChunk( &chunks[6], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[7], 8, 0, -ONE/32, 0);
			MakeTunnelChunk( &chunks[8], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[9], 8, 0, ONE/32, 0);
			MakeTunnelChunk( &chunks[10], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[11], 8, 0, -ONE/32, 0);
			MakeTunnelChunk( &chunks[12], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[13], 8, 0, -ONE/32, 0);
			MakeTunnelChunk( &chunks[14], 22, 0, 0, 0);
			MakeTunnelChunk( &chunks[15], 22, 0, 0, 0);
			MakeTunnelChunk( &chunks[16], 8, 0, -ONE/32, 0);

			SetDescriptionSizeParameters(track, 
						SQUARE_SIZE * 4, SQUARE_SIZE * 4);
			break;
		case THIRTEENTH:
			numberChunks = 8;

			MakeTunnelChunk( &chunks[0], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[1], 8, -ONE/16, 0, 0);
			MakeTunnelChunk( &chunks[2], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[3], 8, -ONE/16, 0, 0);
			MakeTunnelChunk( &chunks[4], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[5], 8, -ONE/16, 0, 0);
			MakeTunnelChunk( &chunks[6], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[7], 8, -ONE/16, 0, 0);
			break;
		case FOURTEENTH:
			numberChunks = 8;

			MakeTunnelChunk( &chunks[0], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[1], 8, ONE/16, 0, 0);
			MakeTunnelChunk( &chunks[2], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[3], 8, ONE/16, 0, 0);
			MakeTunnelChunk( &chunks[4], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[5], 8, ONE/16, 0, 0);
			MakeTunnelChunk( &chunks[6], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[7], 8, ONE/16, 0, 0);
			break;
		case FIFTEENTH:		// FIFTH in YZ plane
			numberChunks = 16;

				// smooth-curling starfish with just four limbs, fourfold symmetry
			MakeTunnelChunk( &chunks[0], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[1], 8, -ONE/16, 0, 0);
			MakeTunnelChunk( &chunks[2], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[3], 8, ONE/32, 0, 0);
			MakeTunnelChunk( &chunks[4], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[5], 8, -ONE/16, 0, 0);
			MakeTunnelChunk( &chunks[6], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[7], 8, ONE/32, 0, 0);
			MakeTunnelChunk( &chunks[8], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[9], 8, -ONE/16, 0, 0);
			MakeTunnelChunk( &chunks[10], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[11], 8, ONE/32, 0, 0);
			MakeTunnelChunk( &chunks[12], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[13], 8, -ONE/16, 0, 0);
			MakeTunnelChunk( &chunks[14], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[15], 8, ONE/32, 0, 0);

			SetDescriptionSizeParameters(track, 
						SQUARE_SIZE * 4, SQUARE_SIZE * 4);
			break;
		case SIXTEENTH:		// EIGHTH in yz plane
			numberChunks = 16;

				// long stretched oval with two outward kinks on each long part
			MakeTunnelChunk( &chunks[0], 12, 0, 0, 0);
			MakeTunnelChunk( &chunks[1], 8, -ONE/16, 0, 0);
			MakeTunnelChunk( &chunks[2], 12, 0, 0, 0);
			MakeTunnelChunk( &chunks[3], 8, ONE/32, 0, 0);
			MakeTunnelChunk( &chunks[4], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[5], 8, -ONE/16, 0, 0);
			MakeTunnelChunk( &chunks[6], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[7], 8, ONE/32, 0, 0);
			MakeTunnelChunk( &chunks[8], 12, 0, 0, 0);
			MakeTunnelChunk( &chunks[9], 8, -ONE/16, 0, 0);
			MakeTunnelChunk( &chunks[10], 12, 0, 0, 0);
			MakeTunnelChunk( &chunks[11], 8, ONE/32, 0, 0);
			MakeTunnelChunk( &chunks[12], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[13], 8, -ONE/16, 0, 0);
			MakeTunnelChunk( &chunks[14], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[15], 8, ONE/32, 0, 0);

			SetDescriptionSizeParameters(track, 
						SQUARE_SIZE * 4, SQUARE_SIZE * 8);
			break;
		case SEVENTEENTH:		   // NINTH in yz plane
			numberChunks = 14;

				// long stretched oval with kink-to-the-left on each long part
			MakeTunnelChunk( &chunks[0], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[1], 8, -ONE/16, 0, 0);
			MakeTunnelChunk( &chunks[2], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[3], 8, -ONE/32, 0, 0);
			MakeTunnelChunk( &chunks[4], 8, ONE/16, 0, 0);
			MakeTunnelChunk( &chunks[5], 8, -ONE/32, 0, 0);
			MakeTunnelChunk( &chunks[6], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[7], 8, -ONE/16, 0, 0);
			MakeTunnelChunk( &chunks[8], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[9], 8, ONE/32, 0, 0);
			MakeTunnelChunk( &chunks[10], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[11], 8, -ONE/16, 0, 0);
			MakeTunnelChunk( &chunks[12], 2, 0, 0, 0);
			MakeTunnelChunk( &chunks[13], 8, ONE/32, 0, 0);

			SetDescriptionSizeParameters(track, 
						SQUARE_SIZE * 4, SQUARE_SIZE * 4);
			break;
		case EIGHTEENTH:		// TENTH in yz plane
			numberChunks = 16;

				// smooth-curling starfish with just four limbs, fourfold symmetry
			MakeTunnelChunk( &chunks[0], 16, 0, 0, 0);
			MakeTunnelChunk( &chunks[1], 8, -ONE/16, 0, 0);
			MakeTunnelChunk( &chunks[2], 16, 0, 0, 0);
			MakeTunnelChunk( &chunks[3], 8, ONE/32, 0, 0);
			MakeTunnelChunk( &chunks[4], 16, 0, 0, 0);
			MakeTunnelChunk( &chunks[5], 8, -ONE/16, 0, 0);
			MakeTunnelChunk( &chunks[6], 16, 0, 0, 0);
			MakeTunnelChunk( &chunks[7], 8, ONE/32, 0, 0);
			MakeTunnelChunk( &chunks[8], 16, 0, 0, 0);
			MakeTunnelChunk( &chunks[9], 8, -ONE/16, 0, 0);
			MakeTunnelChunk( &chunks[10], 16, 0, 0, 0);
			MakeTunnelChunk( &chunks[11], 8, ONE/32, 0, 0);
			MakeTunnelChunk( &chunks[12], 16, 0, 0, 0);
			MakeTunnelChunk( &chunks[13], 8, -ONE/16, 0, 0);
			MakeTunnelChunk( &chunks[14], 16, 0, 0, 0);
			MakeTunnelChunk( &chunks[15], 8, ONE/32, 0, 0);

			SetDescriptionSizeParameters(track, 
						SQUARE_SIZE * 4, SQUARE_SIZE * 4);
			break;
		case NINETEENTH:			// TWELFTH in yz plane
			numberChunks = 17;

				// complex curler: large rectangle with smaller one added halfway down
				// one of the long sides; all corners smoothly rounded
			MakeTunnelChunk( &chunks[0], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[1], 8, -ONE/32, 0, 0);
			MakeTunnelChunk( &chunks[2], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[3], 8, ONE/32, 0, 0);
			MakeTunnelChunk( &chunks[4], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[5], 8, -ONE/32, 0, 0);
			MakeTunnelChunk( &chunks[6], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[7], 8, -ONE/32, 0, 0);
			MakeTunnelChunk( &chunks[8], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[9], 8, ONE/32, 0, 0);
			MakeTunnelChunk( &chunks[10], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[11], 8, -ONE/32, 0, 0);
			MakeTunnelChunk( &chunks[12], 8, 0, 0, 0);
			MakeTunnelChunk( &chunks[13], 8, -ONE/32, 0, 0);
			MakeTunnelChunk( &chunks[14], 22, 0, 0, 0);
			MakeTunnelChunk( &chunks[15], 22, 0, 0, 0);
			MakeTunnelChunk( &chunks[16], 8, -ONE/32, 0, 0);

			SetDescriptionSizeParameters(track, 
						SQUARE_SIZE * 4, SQUARE_SIZE * 4);
			break;
		default:
			assert(FALSE);
		}

	MakeTunnelDescriptionFromChunks (track, numberChunks, chunks);
}