/************************************************************
 *															*
 *						sound.h								*
 *			   											    *															*
 *				LPGE     1997								*		
 *															*
 *	Copyright (C) 1996 Sony Computer Entertainment Inc.		*
 *	All Rights Reserved										*
 *															*
 ***********************************************************/



#ifndef SOUND_H_INCLUDED


/****************************************************************************
					includes
****************************************************************************/



#include "sys_libs.h"

#include "asssert.h"

#include "general.h"

#include "address.h"

#include "object.h"

#include "main.h"			// frameNumber needed




/****************************************************************************
					constants and structures
****************************************************************************/



	// compile-time overall switch
#define SOUND_ON 1


	  

	// value of status flag for each sound channel
#define OFF 0
#define WAITING_TO_START 1
#define PLAYING 2



typedef struct
{	
	int value;
	int statusFlag;
	int frameToStartOn;
	int duration;
	int program, tone, note;
	int leftVolume, rightVolume;
} VoiceChannelHandler;


#define MAX_VOICES 24		// psx standard




/****************************************************************************
					prototypes
****************************************************************************/



void InitialiseSound (void);

void PlayJasonsTune (void);

void TurnOffJasonsTune (void);

void MakeClunk (void);

void HandleSound (void);

void TurnOnSound (int whichProgram, int whichTone, int whichNote, 
						int delayFromNow, int howLong,
									int leftVolume, int rightVolume);

void CleanUpSound (void);






#define SOUND_H_INCLUDED 1

#endif