/************************************************************
 *															*
 *						text_str.h							*
 *			   											    *															*
 *				LPGE     1997								*		
 *															*
 *	Copyright (C) 1996 Sony Computer Entertainment Inc.		*
 *	All Rights Reserved										*
 *															*
 ***********************************************************/





#ifndef TEXT_STR_H_INCLUDED




/****************************************************************************
					 includes
****************************************************************************/



#include "sys_libs.h"

#include "general.h"

#include "asssert.h"

#include "address.h"

#include "2D1.h"

#include "dump.h"

#include "object.h"

#include "main.h"




/****************************************************************************
					 constants
****************************************************************************/




#define MAX_TEXT_STRINGS 20
#define MAX_STRING_LENGTH 50


#define NORMAL_COLOUR 16912
#define RED_COLOUR 16
#define GREEN_COLOUR (16 << 5)
#define DARK_GREEN_COLOUR (24 << 5)
#define BLUE_COLOUR (16 << 10)
#define YELLOW_COLOUR (16 + (16 << 5))
#define PURPLE_COLOUR (16 + (16 << 10))
#define CYAN_COLOUR ((16 << 10) + (16 << 5))




/****************************************************************************
					 structures
****************************************************************************/



typedef struct
{
	int x, y;
	int scaleX, scaleY;
	int length;
	int colour;
	char data[MAX_STRING_LENGTH];
} TextString;




/****************************************************************************
					 prototypes
****************************************************************************/





	// module initialiser: InitialiseAll
void InitialiseTextStrings (void);

void ClearAllTextStrings (void);

	// module handler: once every frame
void DisplayTextStrings (GsOT* orderingTable);

	// internal
GsSPRITE* GetSpriteForCharacter (char character);

void GetPositionOfCharacter (char character, int *x, int *y);



	// main interface function
	// set colour to 16912 for normal colour
void RegisterTextStringForDisplay (char* string, int x, int y, int colour);

void RegisterStringForPermanentDisplay (char *string, int x, int y, int colour);

void DisplayPermanentStringList (GsOT* orderingTable);



void ApplyStringColouringEffect (int effectID);

void SometimesOscillateStringsColours (void);

void SlowlyOscillateStringsColours (void);




#define TEXT_STR_H_INCLUDED 1

#endif
